/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ANIMATIONSETSETTINGS_H
#define ANIMATIONSETSETTINGS_H

#include <iostream>
#include <string>
#include <vector>
#include "interface_animationObserver.h"
#include "utils.h"
#include "animation.h"
#include "resourcePool.h"
#include "intMap.h"


using namespace std;

/**
	@author Nick Easler,,, <easlern@easlern-laptop>
*/

class Animation;
class ResourcePool;
class AnimationSetSettings{
    public:
        AnimationSetSettings (AnimationSetMap frames, vector< Interface_AnimationObserver* > observers, 
				int currentAnimation, ResourcePool* resources, bool dirty, string animationDefFile){
			this->frames.copyFrom (frames);
			this->animationObservers = observers;
			this->currentAnimation = currentAnimation;
			this->resources = resources;
			this->dirty = dirty;
			this->animationDefFile = animationDefFile;
        }
		virtual ~AnimationSetSettings(){}

		//map< int, Animation* > getFrames(){ return frames; }
		AnimationSetMap getFrames(){ return frames; }
		vector< Interface_AnimationObserver* > getAnimationObservers(){ return animationObservers; }
		int getCurrentAnimation(){ return currentAnimation; }
		ResourcePool* getResources(){ return resources; }
		bool getDirty(){ return dirty; }
		string getAnimationDefFile(){ return animationDefFile; }

    protected:
		void cleanup();
        //map< int, Animation* > frames;
		AnimationSetMap frames;
		vector< Interface_AnimationObserver* > animationObservers;
        int currentAnimation;
		ResourcePool* resources;
		bool dirty;
		string animationDefFile;
};

#endif
