/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef ANIMATIONSETTINGS_H
#define ANIMATIONSETTINGS_H

#include <vector>
#include "interface_animationObserver.h"
#include "resourcePool.h"
#include "stampSet.h"


using namespace std;

/**
	@author Nick Easler,,, <easlern@easlern-laptop>
*/

class StampSet;
class ResourcePool;
class AnimationSettings{
	public:
		AnimationSettings (int timeLength, int timePassed, bool repeating, InterruptFlag interruptibleBy,
				AnimationType animationType, vector< Interface_AnimationObserver* > observers, 
				StampSet* stampSet, vector< int > frames, ResourcePool* resources, const bool& notifiedObservers){
			this->timeLength = timeLength;
			this->timePassed = timePassed;
			this->repeating = repeating;
			this->interruptibleBy = interruptibleBy;
			this->animationType = animationType;
			this->animationObservers = observers;
			this->stampSet = stampSet;
			this->frames = frames;
			this->resources = resources;
			this->notifiedObservers = notifiedObservers;
		}
		~AnimationSettings(){}

        int getTimeLength(){ return timeLength; }
		int getTimePassed(){ return timePassed; }
        bool getRepeating(){ return repeating; }
   	    InterruptFlag getInterruptibleBy(){ return interruptibleBy; }
		AnimationType getAnimationType(){ return animationType; }
		vector< Interface_AnimationObserver* > getAnimationObservers(){ return animationObservers; }
		StampSet* getStampSet(){ return stampSet; }
		vector< int > getFrames(){ return frames; }
		ResourcePool* getResources(){ return resources; }
		bool getNotifiedObservers(){ return notifiedObservers; }

	private:
        int timeLength, timePassed;
        bool repeating;
   	    InterruptFlag interruptibleBy;
		AnimationType animationType;
		vector< Interface_AnimationObserver* > animationObservers;
		StampSet* stampSet;
		vector< int > frames;
		ResourcePool* resources;
		bool notifiedObservers;
};


#endif
