#include "audioEffectTone.h"
#include "interface_audioProcessingManager.h"
#include "audioData.h"
#include "utils.h"
#include <math.h>

using namespace std;


AudioEffectTone::AudioEffectTone (unsigned int period) : period_ (period) { }
AudioEffectTone::~AudioEffectTone(){}

Uint32 AudioEffectTone::getTimeLengthOffset (Uint32 currentLength){
	return 0;
}
void AudioEffectTone::processAudio (Interface_AudioProcessingManager* manager){
	Uint32 currentSampleIndex = manager->getCurrentSampleIndex();
	unsigned int maxMag = 32765; // HAX assumes 16 bit
	//cout << "tone processing from " << currentSampleIndex << " to " << currentSampleIndex + manager->getNumberOfSamplesToProcess() << endl;

	for (unsigned int x = 0; x < manager->getNumberOfSamplesToProcess(); x++){
		//cout << "setting tone sample " << x << endl;
		double mult = getVolumeMultiplierAtOffset (currentSampleIndex + x);
		short newLeft = short (maxMag * mult); //if (std::abs (newLeft) < 100) newLeft = 0;
		short newRight = short (maxMag * mult); //if (std::abs (newRight) < 100) newRight = 0;
		Audio::AudioSample newSample (newLeft, newRight, 16); // HAX assumes 16 bit
		//cout << "tone creating sample " << newSample.getLeftSample() << ", " << newSample.getRightSample() << endl;
		manager->setCompositeSample (x, newSample);
		//newSample = Utils::audioBlend (newSample, manager->getCompositeSample (x));
		//manager->setCompositeSample (x, newSample);
	}
}

double AudioEffectTone::getVolumeMultiplierAtOffset (unsigned int offset){
	unsigned int where = offset % period_;
	//cout << "where is " << where << ", period is " << period_ << endl;
	double offsetPart = (where * 1.0 / period_);
	//cout << "mult offset is " << offsetPart << endl;
	double negOneToOne = sin (offsetPart * 2 * Utils::PI());
	double mult = negOneToOne;
	//mult = (negOneToOne + 1) / 2;
	//cout << "mult is " << mult << endl;
	return mult;
}
