#ifndef AUDIO_PROCESSING_MANAGER_H
#define AUDIO_PROCESSING_MANAGER_H

#include "interface_audioProcessingManager.h"
#include "audioData.h"


namespace Audio{
	class AudioProcessingManager : public Interface_AudioProcessingManager{
		public:
			AudioProcessingManager (unsigned int bitSize, unsigned int rate);
			virtual ~AudioProcessingManager();

			virtual void startEffectStack (AudioData&, unsigned int, unsigned int);
			virtual void endEffectStack();

			virtual AudioData getCompositeAudioData();
			virtual Audio::AudioData getCopyOfSourceData();
			virtual Audio::AudioData getCopyOfSourceDataInWindow();

			virtual unsigned int getNumberOfSamplesToProcess();
			virtual unsigned int getCurrentSampleIndex();
			virtual AudioSample getSourceSample (int);
			virtual AudioSample getCompositeSample (int);
			virtual AudioSample getSourceSampleByTime (int);
			virtual AudioSample getCompositeSampleByTime (int);
	
			virtual void setCompositeSample (int, const AudioSample&);
			virtual void setCompositeSamples (Audio::AudioData& from, unsigned int start, unsigned int count, unsigned int toStart);

		private:
			AudioData sourceData_;
			AudioData compositeData_;
			unsigned int sampleWindowStart_;
			unsigned int sampleWindowEnd_;
	};
}


#endif 
