#ifndef BASKET_H
#define BASKET_H

#include <string>
#include "sprite.h"


#define BASKET_LEFT 1
#define BASKET_RIGHT 2

#define ANIM_BASKET_STAND_LEFT 0
#define ANIM_BASKET_STAND_RIGHT 1
#define ANIM_BASKET_WALK_LEFT 2
#define ANIM_BASKET_WALK_RIGHT 3

#define BASKET_WALK_SPEED 30


class Basket : public Sprite{
	public:
		Basket (Surface* owner, const Rect& perimeter, const std::string& spriteSheet = "monkey.bmp", 
			const std::string& spriteDef = "basket.set");
		virtual ~Basket();

		bool update (unsigned int timePassed);

		void setLeftBound (int);
		void setRightBound (int);

	private:
		void moveRight();
		void moveLeft();
		void standStill();

		void playStandingAnim();
		void playWalkingAnim();
		bool animPlaying (int, int);
		bool walkAnimPlaying();
		bool standingAnimPlaying();

		unsigned int moveFlags;
		unsigned int facingFlags;

		bool goingLeft;

		int timeSinceDecision;
		int decision;
		int leftBound_;
		int rightBound_;
};



#endif
