/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "borderLeg.h"
#include <iostream>
#include "border.h"
#include <fstream>

using namespace std;


BorderLeg::BorderLeg (Border* owner, string definition) : Wallpaper(){
	if (!owner){
		string message = "BorderLeg got a NULL owner!";
		cout << message << endl;
		throw (message);
	}
	if (definition == ""){
		string message = "BorderLeg got a '' definition file!";
		cout << message << endl;
		throw (message);
	}
	setResourcePool (owner->getResourcePool());
	frameThickness = 0;
	ifstream defFile;
	defFile.open (definition.c_str());
	defFile >> frameThickness;
	string wallpaperDef;
	defFile >> wallpaperDef;
	defFile.close();
	setDefinitionFile (wallpaperDef);
}
BorderLeg::~BorderLeg(){
}
