#ifndef CAMERA_H
#define CAMERA_H

#include <vector>


class Interface_CameraEventObserver;
class TwoDimensionalTransition;
class Camera{
	public:
		Camera();
		~Camera();

		bool update (unsigned int timePassed);

		double getX() const;
		double getY() const;
		double getFinalX() const;
		double getFinalY() const;
		bool addTransition (TwoDimensionalTransition* transition);
		bool removeTransition (TwoDimensionalTransition* transition);

		bool addObserver (Interface_CameraEventObserver* observer);
		bool removeObserver (Interface_CameraEventObserver* observer);

		void clearTransitions();

	protected:
		void cleanupTransitions();

	private:
        Camera& operator= (const Camera& model){ return *this; }
		Camera (const Camera& model){ }

		std::vector<TwoDimensionalTransition*> transitions;
		std::vector<Interface_CameraEventObserver*> observers;

		double lastX;
		double lastY;
};


#endif
