#include "coconut.h"
#include "sprite.h"
#include "animationSet.h"


Coconut::Coconut (Surface* owner, const std::string& bitmap)
		: Sprite (owner, bitmap){
	size_ = COCONUT_LARGE;
	if (bitmap == COCONUT_SMALL_RED || bitmap == COCONUT_SMALL_GREEN || bitmap == COCONUT_SMALL_BLUE || bitmap == COCONUT_SMALL_BROWN)
		size_ = COCONUT_SMALL;
	collector_ = 3;
	if (bitmap == COCONUT_SMALL_RED || bitmap == COCONUT_LARGE_RED) collector_ = 0;
	if (bitmap == COCONUT_SMALL_GREEN || bitmap == COCONUT_LARGE_GREEN) collector_ = 1;
	if (bitmap == COCONUT_SMALL_BLUE || bitmap == COCONUT_LARGE_BLUE) collector_ = 2;

	pointValue = 1;

	this->bitmap = bitmap;

	grounded = true;

	yVelocity = 0;
}
Coconut::~Coconut() { }

bool Coconut::update (unsigned int timePassed){
	bool result = Sprite::update (timePassed);
	if (!isGrounded()) yVelocity -= COCONUT_GRAVITY * (timePassed / 1000.0);
	double amountToMoveY = -yVelocity * (timePassed / 1000.0);
	moveXY (0, amountToMoveY);
	return result;
}

bool Coconut::isGrounded(){
	return grounded;
}
void Coconut::fall(){
	grounded = false;
}
void Coconut::land(){
	grounded = true;
	yVelocity = 0;
}

int Coconut::getSize(){ return size_; }
int Coconut::getCollector(){ return collector_; }

