#ifndef COCONUT_H
#define COCONUT_H

#include <string>
#include "sprite.h"


#define COCONUT_SMALL 0
#define COCONUT_LARGE 1

#define COCONUT_SMALL_RED "coconut.small.red.bmp"
#define COCONUT_SMALL_GREEN "coconut.small.green.bmp"
#define COCONUT_SMALL_BLUE "coconut.small.blue.bmp"
#define COCONUT_SMALL_BROWN "coconut.small.brown.bmp"
#define COCONUT_LARGE_RED "coconut.large.red.bmp"
#define COCONUT_LARGE_GREEN "coconut.large.green.bmp"
#define COCONUT_LARGE_BLUE "coconut.large.blue.bmp"
#define COCONUT_LARGE_BROWN "coconut.large.brown.bmp"

#define ANIM_COCONUT_RED 0
#define ANIM_COCONUT_GREEN 1
#define ANIM_COCONUT_BLUE 2
#define ANIM_COCONUT_BROWN 3

#define COCONUT_GRAVITY 500


class Coconut : public Sprite{
	public:
		Coconut (Surface* owner, const std::string&);
		virtual ~Coconut();

		virtual bool update (unsigned int timePassed);

		std::string getBitmap(){ return bitmap; }

		int getSize();
		int getCollector();

		void fall();
		bool isGrounded();
		void land();

		void setPointValue (int points){ pointValue = points; }
		int getPointValue(){ return pointValue; }

	private:
		int size_;
		int collector_;
		bool grounded;
		double yVelocity;
		std::string bitmap;
		int pointValue;
};



#endif
