/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef DIALOGUE_BOX_H
#define DIALOGUE_BOX_H

#include "surface.h"
#include "rect.h"

using namespace std;


/**
	@author Nick Easler,,, <easlern@easlern-laptop>
*/

#define DIALOGUE_BOX_ARROW_LEFT 0
#define DIALOGUE_BOX_ARROW_RIGHT 1

class Wallpaper;
class Text;
class Border;
class Sprite;
class DialogueBox : public Surface{
    public:
        DialogueBox (Surface* parent, const string& definition, const double& x, const double& y, const int& xMargin, const int& yMargin, 
			const string& message = "", const Rect& sourceAbsRect = Rect (0, 0, 0, 0));
        virtual ~DialogueBox();

		void setSourceRect (const Rect& source){ this->source = source; refreshArrowThingLocation(); }
		Rect getSourceRect() const{ return source; }

		virtual void setX (double x);
		virtual void setY (double y);
		virtual void setZ (double z);

	protected:
		void refreshArrowThingLocation();

	private:
		string currentMessage;
		string definitionFilename;
		Text* textControl;
		Wallpaper* background;
		Border* backgroundBorder;
		Rect source;
		Sprite* arrowThing;
		int xMargin;
		int yMargin;
};

#endif
