#include "effect.h"
#include <iostream>

using namespace std;


Effect::Effect (int timeLength, double startX, double startY){
	this->timeLength = timeLength;
	this->timePassed = 0;
	this->startX = startX;
	this->startY = startY;
	this->active = true;
	this->quality_ = qualityHigh;
}
Effect::Effect (const Effect& model){
	timeLength = model.getTimeLength();
	timePassed = 0;
	startX = model.getStartX();
	startY = model.getStartY();
	active = model.getActive();
	quality_ = model.getQuality();
}

bool Effect::update (int timePassed){
	//cout << "Effect updating by " << timePassed << endl;

	if (! this->getLive()) return false;

	this->timePassed += timePassed;
	if (this->timeLength > 0 && this->timePassed >= timeLength){
		notifyObserversOfCompletion();
	}
	return false;
}

vector< Rect > Effect::getViewports (Rect& absoluteSourceRect){
	vector< Rect > retValue;
	return retValue;
}

vector< Rect > Effect::getOcclusionports (Rect& absoluteSourceRect){
	vector< Rect > retValue;
	return retValue;
}

void Effect::notifyObserversOfCompletion(){
	vector<Interface_EffectObserver*> observersCopy = observers;
	for (vector< Interface_EffectObserver* >::iterator iter = observersCopy.begin(); iter != observersCopy.end(); iter++){
		(*iter)->effectComplete (this);
	}
}

bool Effect::hasObserver (Interface_EffectObserver* observer){
	for (vector< Interface_EffectObserver* >::iterator iter = observers.begin(); iter != observers.end(); iter++){
		if (observer == *iter){
			return true;
		}
	}
	return false;
}

void Effect::addObserver (Interface_EffectObserver* observer){
	if (! hasObserver (observer)){
		observers.push_back (observer);
	}
}

void Effect::removeObserver (Interface_EffectObserver* observer){
	for (vector< Interface_EffectObserver* >::iterator iter = observers.begin(); iter != observers.end(); iter++){
		if (observer == *iter){
			observers.erase (iter);
			break;
		}
	}
}
