#include "effectBloom.h"
#include <iostream>
#include "utils.h"
#include "imageProcessingSurfaceManager.h"

using namespace std;


Effect* EffectBloom::clone(){ return new EffectBloom(); }

void EffectBloom::processImagePostDraw (ImageProcessingSurfaceManager* manager){

	Rect effectRect = manager->getBlittingRect();

	for (int y = int (effectRect.getY()) - BLOOM_RADIUS; y < int (effectRect.getY() + effectRect.getHeight()) + BLOOM_RADIUS; y++){
		for (int x = int (effectRect.getX()) - BLOOM_RADIUS; x < int (effectRect.getX() + effectRect.getWidth()) + BLOOM_RADIUS; x++){

			if (!manager->blittingPixelIsTransparent (x, y)) continue;

			Uint16 targetPixel = manager->getTargetPixel (x, y);

			for (int y2 = y - BLOOM_RADIUS; y2 < y + BLOOM_RADIUS; y2++){
				for (int x2 = x - BLOOM_RADIUS; x2 < x + BLOOM_RADIUS; x2++){

					if (manager->blittingPixelIsTransparent (x2, y2)) continue;

					Uint16 bloomingPixel = manager->getBlittingPixel (x2, y2);

					double distance = Utils::get2dDistance (Point (x, y), Point (x2, y2));
	
					double weight = 1.0 / (1.0 + (distance * 1.0));

					targetPixel = Utils::linearPixelBlendRGB (targetPixel, bloomingPixel, weight);

				}
			}

			manager->setCompositePixel (x, y, targetPixel);

		}
	}

}
