#include "effectPanIn.h"
#include <iostream>

using namespace std;


EffectPanIn::EffectPanIn (int timeLength) : Effect (timeLength){}

vector< Rect > EffectPanIn::getViewports (Rect& absoluteSourceRect){

	vector< Rect > retValue;

	double centerX = absoluteSourceRect.getCenterX();
	double centerY = absoluteSourceRect.getCenterY();
	double sourceX = absoluteSourceRect.getX();
	double sourceY = absoluteSourceRect.getY();
	double width = absoluteSourceRect.getWidth();
	double height = absoluteSourceRect.getHeight();
	int totalTime = 1;
	if (getTimeLength() > 0) totalTime = getTimeLength();
	double percentDone = (1.0 * getTimePassed()) / totalTime;
	double percentRemaining = 1.0 - percentDone;
	double fixedX = double (sourceX * percentDone + centerX * percentRemaining);
	double fixedY = double (sourceY * percentDone + centerY * percentRemaining);
	double fixedWidth = double (width * percentDone);
	double fixedHeight = double (height * percentDone);
	
	Rect viewport (fixedX, fixedY, fixedWidth, fixedHeight);

	retValue.push_back (viewport);

	//cout << "Pan in's viewport is now " << viewport.toString() << endl;

	return retValue;
}
