#ifndef EFFECTPHASE_H
#define EFFECTPHASE_H


#include "effect.h"

class ImageProcessingSurfaceManager;
class EffectPhase : public Effect{

	public:
		EffectPhase (const int& timeLength, const int& phasePeriodInSeconds = 1) : Effect (timeLength){
			this->phasePeriodInSeconds = phasePeriodInSeconds;
		};
		virtual ~EffectPhase(){}

		virtual Effect* clone(){ return new EffectPhase (*this); }

		virtual bool update (int timePassed);

		virtual unsigned int getActiveProcessors(){ return EFFECT_IMAGE_PROCESSOR; }

		virtual void processImage (ImageProcessingSurfaceManager* manager);

		virtual void getDirtyRects (Rect& absoluteSourceRect, vector<Rect>& runningList);

	protected:

	private:
		int phasePeriodInSeconds;
};


#endif
