#include "effectSegmentContainerVisualizer.h"
#include "imageProcessingSurfaceManager.h"
#include "geometry.h"
#include <list>


void EffectSegmentContainerVisualizer::processImagePostDraw (ImageProcessingSurfaceManager* manager){
	int baseX = getDrawOffsetX();
	int baseY = getDrawOffsetY();
	std::vector<Line> allSegments;
	container_->getAllSegments (allSegments);
	//if (allSegments.size() > 0) cout << "Processing container visualizer " << endl;
	for (unsigned int x = 0; x < allSegments.size(); x++){
		std::list<Point> rasterized;
		Utils::rasterizeLine (rasterized, allSegments [x]);
		for (std::list<Point>::iterator iter = rasterized.begin(); iter != rasterized.end(); iter++){
			int locX = baseX + (iter->getX() * granularity_);
			int locY = baseY + (iter->getY() * granularity_);
			manager->setCompositePixel (locX, locY, 0xff00);
			//manager->setCompositePixel (locX + 1, locY, 0xff00);
			//manager->setCompositePixel (locX - 1, locY, 0xff00);
			//manager->setCompositePixel (locX, locY + 1, 0xff00);
			//manager->setCompositePixel (locX, locY - 1, 0xff00);
		}
	}
}

Effect* EffectSegmentContainerVisualizer::clone(){
	return new EffectSegmentContainerVisualizer (container_, granularity_);
}

void EffectSegmentContainerVisualizer::setDrawOffset (int x, int y){
	offsetX_ = x;
	offsetY_ = y;
}
int EffectSegmentContainerVisualizer::getDrawOffsetX(){
	return offsetX_;
}
int EffectSegmentContainerVisualizer::getDrawOffsetY(){
	return offsetY_;
}

