#include "effectSoftShadow.h"
#include <iostream>
#include "utils.h"
#include "imageProcessingSurfaceManager.h"

using namespace std;


void EffectSoftShadow::processImage (ImageProcessingSurfaceManager* manager){

	//cout << "Processing shadow." << endl;
	
	int offsetX = getShadowOffsetX();
	int offsetY = getShadowOffsetY();

	Rect effectRect = Rect (manager->getBlittingRect());
	//cout << "effectRect starts as " << effectRect.toString() << endl;
	effectRect.setXY (effectRect.getX() + offsetX, effectRect.getY() + offsetY);
	effectRect.setWidth (effectRect.getWidth() - offsetX);
	effectRect.setHeight (effectRect.getHeight() - offsetY);
	Rect screenRect = Rect (0, 0, 640, 480);
	effectRect.trimTo (screenRect);
	if (effectRect.getWidth() < 1 || effectRect.getHeight() < 1) return;
	//cout << "past the return" << endl;

	int x1 = int (effectRect.getX()); int x2 = x1 + int (effectRect.getWidth() + offsetX);
	int y1 = int (effectRect.getY()); int y2 = y1 + int (effectRect.getHeight() + offsetY);
/*
	Rect blitRect = manager->getBlittingRect();
	blitRect.setX (blitRect.getX() + 40);
	for (int x = blitRect.getX(); x < blitRect.getX() + blitRect.getWidth(); x++){
		manager->setCompositePixel (x, blitRect.getY(), 0xffff);
	}
	for (int y = blitRect.getY() + 1; y < blitRect.getY() + blitRect.getHeight(); y++){
		manager->setCompositePixel (blitRect.getX(), y, 0xffff);
		manager->setCompositePixel (blitRect.getX() + blitRect.getWidth() - 1, y, 0xffff);
	}
	for (int x = blitRect.getX(); x < blitRect.getX() + blitRect.getWidth(); x++){
		manager->setCompositePixel (x, blitRect.getY() + blitRect.getHeight(), 0xffff);
	}
return;
*/	//cout << "blitting rect is " << manager->getBlittingRect().toString() << endl;
	//cout << "composite rect is " << manager->getCompositeRect().toString() << endl;
	/*
	for (int y = y1; y < y2; y++){
		for (int x = x1; x < x2; x++){
			if (! manager->compositePixelIsTransparent (x, y)) manager->setCompositePixel (x, y - 100, 0xffff);
		}
	}

return;*/
	for (int y = y1; y < y2; y++){
		for (int x = x1; x < x2; x++){
			if (! manager->compositePixelIsTransparent (x - offsetX, y - offsetY)){
				//cout << "comp pixel is " << manager->getCompositePixel (x, y) << endl;
				//cout << "blitting colorkey is " << manager->getBlittingSurface()->format->colorkey << endl;
				//cout << "effect colorkey is " << manager->getEffectSurface()->format->colorkey << endl;
				if (manager->compositePixelIsTransparent (x, y)){
					//cout << x << "," << y << " is transparent!" << endl;
					Uint16 pixelToShade = manager->getTargetPixel (x, y);
					//manager->setCompositePixel (x + offsetX, y + offsetY, pixelToShade);
					manager->setCompositePixel (x, y, (pixelToShade >> 1) & 0x7bef);
					//manager->setCompositePixel (x, y - 50, 0xffff);
				}
			}	
			//manager->setCompositePixel (x, y, 0xffff);
			//if (x == x2 - 1) cout << "end of the x loop" << endl;
		}
		//if (y == y2 - 1) cout << "end of the y loop" << endl;
	}

	//cout << "Made it to end of function" << endl;

}
