#include "effectTranslucent.h"
#include <iostream>
#include "utils.h"
#include "imageProcessingSurfaceManager.h"

using namespace std;


void EffectTranslucent::processImage (ImageProcessingSurfaceManager* manager){

	Rect effectRect = Rect (manager->getBlittingRect());
	//cout << "effect translucent effectRect starts as " << effectRect.toString() << endl;

	for (int y = int (effectRect.getY()); y < int (effectRect.getY() + effectRect.getHeight()); y++){
		for (int x = int (effectRect.getX()); x < int (effectRect.getX() + effectRect.getWidth()); x++){
			if (! manager->compositePixelIsTransparent (x, y)){
				Uint16 pixelToShade = manager->getTargetPixel (x, y);
				Uint16 blittingPixel = manager->getCompositePixel (x, y);
				manager->setCompositePixel (x, y, Utils::linearPixelBlendRGB (blittingPixel, pixelToShade, weight));
			}	
		}
	}

}
