#ifndef EVENT_H
#define EVENT_H

#include <vector>

#include "interface_event.h"


class Interface_EventController;
class Interface_EventTrigger;
class Interface_EventResult;
class Event : public Interface_Event{
	
	public:

		Event(){}
		virtual ~Event();
		Event (const Event& model);
		Event& operator= (const Event& model);

		virtual bool operator== (const Event& model) const;

		virtual bool check (Interface_EventController* controller);

		virtual bool addTrigger (Interface_EventTrigger* trigger);
		virtual bool addResult (Interface_EventResult* result);

		virtual std::vector<Interface_EventTrigger*> getTriggers() const;
		virtual std::vector<Interface_EventResult*> getResults() const;

		virtual Event* clone() const;

		virtual bool hasTrigger (const Interface_EventTrigger* trigger) const;
		virtual bool hasResult (const Interface_EventResult* result) const;

	private:

		std::vector<Interface_EventTrigger*> triggers;
		std::vector<Interface_EventResult*> results;
};


#endif
