#include "eventController.h"
#include "interface_event.h"

#include <iostream>

using namespace std;


EventController::EventController(){
	automaticRefresh = true;
	changed = false;
}
EventController::~EventController(){
	for (vector<Interface_Event*>::iterator iter = events.begin(); iter != events.end(); iter++){
		delete *iter;
	}
}

string EventController::getVariable (const string& variable) const{
	//cout << "getting variable " << variable << endl;
	if (variable [0] == '*'){ 
		return getVariable (getVariable (variable.substr (1)));
	}
	map<string,string>::const_iterator iter = variables.find (variable);
	string result = "";
	if (iter != variables.end()) result = iter->second;
	//cout << "getting variable " << variable << ", got " << result << endl;
	return result;
}

void EventController::setVariable (const string& variable, const string& value){
	//cout << "setVariable " << variable << "," << value << endl;
	if (value [0] == '*'){
		setVariable (variable, getVariable (value.substr (1)));
		return;
	}
	if (variable [0] == '*'){
		setVariable (getVariable (variable.substr (1)), value);
		return;
	}
	string checkValue = value;
	if (variables [variable] != checkValue){
		//cout << "setting variable " << variable << " to " << checkValue << endl;
		variables [variable] = checkValue;
		changed = true;
		if (automaticRefresh) refresh();
	}
}

void EventController::refresh(){
	//cout << "**** refreshing" << endl;
	automaticRefresh = false;
	do{
		changed = false;
		for (vector<Interface_Event*>::iterator iter = events.begin(); iter != events.end(); iter++){
			(*iter)->check (this);		
		}
	} while (changed);
	automaticRefresh = true;
}

bool EventController::addEvent (Interface_Event* event){
	if (! hasEvent (event)){ 
		events.push_back (event);
		return true;
	}
	return false;
}
bool EventController::hasEvent (const Interface_Event* event) const{
	for (vector<Interface_Event*>::const_iterator iter = events.begin(); iter != events.end(); iter++){
		if (**iter == *event) return true;
	}
	return false;
}
