#ifndef EVENTCONTROLLER_H
#define EVENTCONTROLLER_H


#include <string>
#include <vector>
#include <map>

#include "interface_eventController.h"


class Interface_Event;
class EventController : public Interface_EventController{

	public:

		EventController();
		virtual ~EventController();

		std::string getVariable (const std::string& variable) const;
		void setVariable (const std::string& variable, const std::string& value);

		bool addEvent (Interface_Event* event);

		bool hasEvent (const Interface_Event* event) const;

		void refresh();
	
	private:

		EventController (const EventController& model){}
		EventController& operator= (const EventController& model){ return *this; }
		bool operator== (const EventController& model) const{ return false; }

		std::vector<Interface_Event*> events;
		std::map<std::string,std::string> variables;

		// TODO: these should be taken out and i should be getting changes from results instead of passing myself
		//	to be messed with. yuck go no further!
		bool automaticRefresh;
		bool changed;

};


#endif
