#include "eventResultSet.h"
#include <string>

#include "interface_eventController.h"

using namespace std;


EventResultSet::EventResultSet (const EventResultSet& model){
	*this = model;
}
EventResultSet& EventResultSet::operator= (const EventResultSet& model){
	if (this != &model){
		variable = model.getVariable();
		value = model.getValue();
	}
	return *this;
}
EventResultSet::EventResultSet (const string& variable, const string& value){
	this->variable = variable;
	this->value = value;
}
EventResultSet* EventResultSet::clone() const{
	return new EventResultSet (*this);
}

void EventResultSet::trigger (Interface_EventController* controller){
	controller->setVariable (variable, value);
}

string EventResultSet::getVariable() const{
	return variable;
}
string EventResultSet::getValue() const{
	return value;
}

bool EventResultSet::operator== (const EventResultSet& model) const{
	return getVariable() == model.getVariable() && getValue() == model.getValue();
}
