#ifndef EVENTTRIGGER_H
#define EVENTTRIGGER_H

#include <vector>
#include <stdlib.h>
#include "interface_eventTrigger.h"


class Interface_EventTriggerRequirement;
class Interface_EventController;
class EventTrigger : public Interface_EventTrigger{

	public:
	
		EventTrigger();
		virtual ~EventTrigger();
		EventTrigger (const EventTrigger& model);
		EventTrigger& operator= (const EventTrigger& model);

		virtual bool operator== (const EventTrigger& model) const;

		virtual EventTrigger* clone() const;

		virtual bool addRequirement (Interface_EventTriggerRequirement* requirement);
		virtual bool hasRequirement (const Interface_EventTriggerRequirement* requirement) const;

		virtual bool check (const Interface_EventController* controller);

		virtual std::vector<Interface_EventTriggerRequirement*> getRequirements() const;

	private:

		std::vector<Interface_EventTriggerRequirement*> requirements;
};


#endif
