#include "eventTriggerRequirementEqual.h"
#include "interface_eventController.h"
#include <string>
#include <iostream>

using namespace std;


EventTriggerRequirementEqual::EventTriggerRequirementEqual (const EventTriggerRequirementEqual& model){
	*this = model;
}
EventTriggerRequirementEqual& EventTriggerRequirementEqual::operator= (const EventTriggerRequirementEqual& model){
	if (this != &model){
		variable = model.variable;
		value = model.value;
	}
	return *this;
}
EventTriggerRequirementEqual::EventTriggerRequirementEqual (const EventVariable& variable, const EventValue& value){
	this->variable = variable;
	this->value = value;
	//cout << "req equal created with var " << this->variable.getRawVariable() << ", value " << this->value.getRawValue() << endl;
}
EventTriggerRequirementEqual* EventTriggerRequirementEqual::clone() const{
	return new EventTriggerRequirementEqual (*this);
}

bool EventTriggerRequirementEqual::satisfied (const Interface_EventController* controller) const{
	//cout << "trigger requirement trying variable, value: " << variable.getRawVariable() << ", " << value.getRawValue() << endl;
	if (controller->getVariable (variable.getVariable()) == value.getValue()){
		//cout << "satisfied." << endl;
		return true;
	}
	//cout << "not satisfied" << endl;
	return false;
}

bool EventTriggerRequirementEqual::operator== (const EventTriggerRequirementEqual& model) const{
	return (getVariable() == model.getVariable()) && (getValue() == model.getValue());
}

EventVariable EventTriggerRequirementEqual::getVariable() const{
	return variable;
}
EventValue EventTriggerRequirementEqual::getValue() const{
	return value;
}
