#include "eventTriggerRequirementGreaterThan.h"
#include "interface_eventController.h"
#include <string>
#include <iostream>

using namespace std;


EventTriggerRequirementGreaterThan::EventTriggerRequirementGreaterThan (const EventTriggerRequirementGreaterThan& model){
	*this = model;
}
EventTriggerRequirementGreaterThan& EventTriggerRequirementGreaterThan::operator= (const EventTriggerRequirementGreaterThan& model){
	if (this != &model){
		variable = model.variable;
		value = model.value;
	}
	return *this;
}
EventTriggerRequirementGreaterThan::EventTriggerRequirementGreaterThan (const EventVariable& variable, const EventValue& value){
	this->variable = variable;
	this->value = value;
}
EventTriggerRequirementGreaterThan* EventTriggerRequirementGreaterThan::clone() const{
	return new EventTriggerRequirementGreaterThan (*this);
}

bool EventTriggerRequirementGreaterThan::satisfied (const Interface_EventController* controller) const{
	//cout << "trigger requirement trying variable, value " << variable << ", " << value << endl;
	return atoi (controller->getVariable (variable.getVariable()).c_str()) > atoi (value.getValue().c_str());
}

bool EventTriggerRequirementGreaterThan::operator== (const EventTriggerRequirementGreaterThan& model) const{
	return getVariable() == model.getVariable() && getValue() == model.getValue();
}

EventVariable EventTriggerRequirementGreaterThan::getVariable() const{
	return variable;
}
EventValue EventTriggerRequirementGreaterThan::getValue() const{
	return value;
}
