#include "eventTriggerRequirementLessThan.h"
#include "interface_eventController.h"
#include <string>
#include <iostream>

using namespace std;


EventTriggerRequirementLessThan::EventTriggerRequirementLessThan (const EventTriggerRequirementLessThan& model){
	*this = model;
}
EventTriggerRequirementLessThan& EventTriggerRequirementLessThan::operator= (const EventTriggerRequirementLessThan& model){
	if (this != &model){
		variable = model.variable;
		value = model.value;
	}
	return *this;
}
EventTriggerRequirementLessThan::EventTriggerRequirementLessThan (const EventVariable& variable, const EventValue& value){
	this->variable = variable;
	this->value = value;
}
EventTriggerRequirementLessThan* EventTriggerRequirementLessThan::clone() const{
	return new EventTriggerRequirementLessThan (*this);
}

bool EventTriggerRequirementLessThan::satisfied (const Interface_EventController* controller) const{
	//cout << "trigger requirement trying variable, value " << variable << ", " << value << endl;
	return atoi (controller->getVariable (variable.getVariable()).c_str()) < atoi (value.getValue().c_str());
}

bool EventTriggerRequirementLessThan::operator== (const EventTriggerRequirementLessThan& model) const{
	return getVariable() == model.getVariable() && getValue() == model.getValue();
}

EventVariable EventTriggerRequirementLessThan::getVariable() const{
	return variable;
}
EventValue EventTriggerRequirementLessThan::getValue() const{
	return value;
}
