#include "eventTriggerRequirementLessThanOrEqualTo.h"
#include "interface_eventController.h"
#include <string>
#include <iostream>

using namespace std;


EventTriggerRequirementLessThanOrEqualTo::EventTriggerRequirementLessThanOrEqualTo (const EventTriggerRequirementLessThanOrEqualTo& model){
	*this = model;
}
EventTriggerRequirementLessThanOrEqualTo& EventTriggerRequirementLessThanOrEqualTo::operator= (const EventTriggerRequirementLessThanOrEqualTo& model){
	if (this != &model){
		variable = model.variable;
		value = model.value;
	}
	return *this;
}
EventTriggerRequirementLessThanOrEqualTo::EventTriggerRequirementLessThanOrEqualTo (const EventVariable& variable, const EventValue& value){
	this->variable = variable;
	this->value = value;
}
EventTriggerRequirementLessThanOrEqualTo* EventTriggerRequirementLessThanOrEqualTo::clone() const{
	return new EventTriggerRequirementLessThanOrEqualTo (*this);
}

bool EventTriggerRequirementLessThanOrEqualTo::satisfied (const Interface_EventController* controller) const{
	//cout << "trigger requirement trying variable, value " << variable << ", " << value << endl;
	//cout << "variable's set to " << controller->getVariable (variable) << endl;
	//cout << "variable versus value tested against: " << atoi (controller->getVariable (variable).c_str()) << "," << atoi (value.c_str()) << endl;
	return atoi (controller->getVariable (variable.getVariable()).c_str()) <= atoi (value.getValue().c_str());
}

bool EventTriggerRequirementLessThanOrEqualTo::operator== (const EventTriggerRequirementLessThanOrEqualTo& model) const{
	return getVariable() == model.getVariable() && getValue() == model.getValue();
}

EventVariable EventTriggerRequirementLessThanOrEqualTo::getVariable() const{
	return variable;
}
EventValue EventTriggerRequirementLessThanOrEqualTo::getValue() const{
	return value;
}
