#include "eventTriggerRequirementNotEqual.h"
#include "interface_eventController.h"

using namespace std;


EventTriggerRequirementNotEqual::EventTriggerRequirementNotEqual (const EventVariable& variable, const EventValue& value){
	this->variable = variable;
	this->value = value;
}
EventTriggerRequirementNotEqual::EventTriggerRequirementNotEqual (const EventTriggerRequirementNotEqual& model){
	*this = model;
}
EventTriggerRequirementNotEqual& EventTriggerRequirementNotEqual::operator= (const EventTriggerRequirementNotEqual& model){
	if (this != &model){
		variable = model.variable;
		value = model.value;
	}
	return *this;
}
EventTriggerRequirementNotEqual* EventTriggerRequirementNotEqual::clone() const{
	return new EventTriggerRequirementNotEqual (*this);
}

bool EventTriggerRequirementNotEqual::satisfied (const Interface_EventController* controller) const{
	return controller->getVariable (variable.getVariable()) != value.getValue();
}

bool EventTriggerRequirementNotEqual::operator== (const EventTriggerRequirementNotEqual& model) const{
	return getVariable() == model.getVariable() && getValue() == model.getValue();
}

EventVariable EventTriggerRequirementNotEqual::getVariable() const{
	return variable;
}
EventValue EventTriggerRequirementNotEqual::getValue() const{
	return value;
}
