#ifndef EVENTVARIABLE_H
#define EVENTVARIABLE_H

#include <string>


class Interface_EventController;

class EventVariable{
	public:
		EventVariable(){
			eventController = NULL;
		}
		EventVariable (const std::string& variable, Interface_EventController* eventController){
			this->variable = variable;
			this->eventController = eventController;
		}
		virtual ~EventVariable(){}

		bool operator== (const EventVariable& other) const{
			return variable == other.variable && eventController == other.eventController;
		}
		EventVariable& operator= (const EventVariable& model){
			variable = model.variable;
			eventController = model.eventController;
			return *this;
		}

		virtual std::string getVariable() const;
		std::string getRawVariable() const{ return variable; }

	private:
		std::string variable;
		Interface_EventController* eventController;
};

#endif
