#ifndef GAME_H
#define GAME_H


#include "gameBase.h"
#include <vector>

class Beach;
class Player;
class EventController;
class PalmTree;
class Surface;
class Basket;
class Coconut;
class Game : public GameBase{
	public:
		Game();
		virtual ~Game();

		virtual void inputHandlerUpdate (const KeyStatesSet&);
		void updatePlayers();
		void updateTrees();
		void updateBasket();
		void updateCoconuts();
		void updateComboCounter (int, int);
		void updateTitles();
		void createTrees();

		std::vector<int> getCoconutCounts();

		virtual void update (unsigned int timePassed);
		virtual void update();
	private:
		void handleGameKeys (const KeyStatesSet&);
		int assignCoconut (int playerToIgnore);
		void assignAllCoconutsTo (int playerToIgnore);
		void killCoconut (Coconut*);

		Beach* beachBackground;
		Player* player1;
		Player* player2;
		Player* player3;
		Surface* playerLabel1;
		Surface* playerLabel2;
		Surface* playerLabel3;
		Surface* comboCounter1;
		Surface* comboCounter2;
		Surface* comboCounter3;
		Surface* titleScreen;
		std::vector<std::pair <PalmTree*, Coconut*> > trees;
		std::vector<Coconut*> coconuts;
		std::vector<Coconut*> scoredCoconuts;
		Basket* basket;

		int timeSinceCoconut;

		EventController* events;

		bool running;
		std::tr1::shared_ptr<SoundInstanceReference> music;

		int basketed;
};



#endif
