#ifndef GAME_BASE_H
#define GAME_BASE_H


/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,                                  *
 *   easlern@easlern-laptop                                                *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifdef WIN32
	#include <memory>
#else
	#include <tr1/memory>
#endif
#include "interface_inputHandlerObserver.h"
#include "audioManager.h"
using namespace std;


class InputHandler;
class Screen;
class ResourcePool;
class GameBase : public Interface_InputHandlerObserver{
	public:
		GameBase();
		virtual ~GameBase();

		virtual void inputHandlerUpdate (const KeyStatesSet&){}

	protected:
		virtual void update();
		virtual void update (Uint32 elapsed);
		virtual void draw();
		Screen& getScreenRef();
		ResourcePool& getResourcesRef();
		Audio::AudioManager& getAudioManagerRef();
		bool getPause();
		void setPause (bool pause);

	private:
		void getInput();

		Uint32 lastUpdate_;
		tr1::shared_ptr<Screen> screen_;
		tr1::shared_ptr<ResourcePool> resources_;
		bool paused_;
};


#endif
