#ifndef INPUTHANDLER_H
#define INPUTHANDLER_H


#include <vector>
#include <SDL/SDL.h>
#include "keyStatesSet.h"


class Interface_InputHandlerObserver;

class InputHandlerObserverState{
	public:
		InputHandlerObserverState (Interface_InputHandlerObserver*);

		void ignoreKey (int);
		void unignoreKey (int);
		bool isIgnoredKey (int) const;
		void push (const KeyStates&);
		Interface_InputHandlerObserver* getObserver();
		KeyStatesSet& getKeyStatesSet();

	private:
		std::vector<bool> ignoreKeys_;
		KeyStatesSet keyStates_;
		Interface_InputHandlerObserver* observer_;
};

typedef std::vector< InputHandlerObserverState > InputHandlerObserverList;

class InputHandler{
	public:
		void setFocus (Interface_InputHandlerObserver*);
		void returnFocus (Interface_InputHandlerObserver*);
		void handleInput();
		void handleInput (const Uint8*);
		void ignoreAllKeys (Interface_InputHandlerObserver*);
		void ignoreKey (Interface_InputHandlerObserver*, int);
		void unignoreKey (Interface_InputHandlerObserver*, int);

	private:
		std::vector<InputHandlerObserverState> observers_;
		KeyStatesSet keyStates_;
};


#endif
