#ifndef INTERFACE_AUDIO_PROCESSING_MANAGER_H
#define INTERFACE_AUDIO_PROCESSING_MANAGER_H

#include "audioData.h"


class Interface_AudioProcessingManager{
	public:
		Interface_AudioProcessingManager (unsigned int bitSize, unsigned int rate){ }
		virtual ~Interface_AudioProcessingManager(){ }

		virtual void startEffectStack (Audio::AudioData& sourceData,
			unsigned int sampleWindowStart, unsigned int sampleWindowEnd) = 0;
		virtual void endEffectStack() = 0;

		virtual Audio::AudioData getCompositeAudioData() = 0;
		virtual Audio::AudioData getCopyOfSourceData() = 0;
		virtual Audio::AudioData getCopyOfSourceDataInWindow() = 0;

		virtual unsigned int getNumberOfSamplesToProcess() = 0;
		virtual unsigned int getCurrentSampleIndex() = 0;
		virtual Audio::AudioSample getSourceSample (int sampleOffset) = 0;
		virtual Audio::AudioSample getCompositeSample (int sampleOffset) = 0;
		virtual Audio::AudioSample getSourceSampleByTime (int msOffset) = 0;
		virtual Audio::AudioSample getCompositeSampleByTime (int msOffset) = 0;
		virtual void setCompositeSample (int sampleOffset, const Audio::AudioSample& sample) = 0;
		virtual void setCompositeSamples (Audio::AudioData& from, unsigned int start, unsigned int count, unsigned int toStart) = 0;
};


#endif
