#ifndef INTERFACE_EVENT_H
#define INTERFACE_EVENT_H

#include <vector>

#include "interface_cloneable.h"


class Interface_EventTrigger;
class Interface_EventResult;
class Interface_EventController;
class Interface_Event : public Interface_Cloneable{
	
	public:

		Interface_Event(){}
		virtual ~Interface_Event(){}

		virtual bool operator== (const Interface_Event& model) const{ return false; }

		virtual bool check (Interface_EventController* controller) = 0;

		virtual bool addTrigger (Interface_EventTrigger* trigger) = 0;
		virtual bool addResult (Interface_EventResult* result) = 0;

		virtual std::vector<Interface_EventTrigger*> getTriggers() const = 0;
		virtual std::vector<Interface_EventResult*> getResults() const = 0;

		virtual bool hasTrigger (const Interface_EventTrigger* trigger) const = 0;
		virtual bool hasResult (const Interface_EventResult* result) const = 0;

		virtual Interface_Event* clone() const = 0;

};


#endif
