#ifndef INTERFACE_EVENTCONTROLLER_H
#define INTERFACE_EVENTCONTROLLER_H


#include <string>
#include <vector>
#include <map>


class Interface_Event;
class Interface_EventController{

	public:

		Interface_EventController(){}
		virtual ~Interface_EventController(){}

		virtual void setVariable (const std::string& variable, const std::string& value) = 0;
		virtual std::string getVariable (const std::string& variable) const = 0;

		virtual bool addEvent (Interface_Event* event) = 0;;
		virtual bool hasEvent (const Interface_Event* event) const = 0;

		// Call this after loading events if some triggers need to spring before setVariable() is ever called.
		// 	(Ain't pretty but it beats the alternatives.)
		virtual void refresh() = 0;

};


#endif
