#include "palmTree.h"
#include "sprite.h"
#include "animationSet.h"


PalmTree::PalmTree (Surface* owner, int size)
		: Sprite (owner, "palmTree.bmp"){
	if (size == PALM_SMALL) loadAnimations ("palmTree.small.set");
	else if (size == PALM_TALL) loadAnimations ("palmTree.tall.set");
	setAnimationTimeLength (ANIM_PALM_STAND, 1000);
	setAnimationTimeLength (ANIM_PALM_SHAKE, 1000);

	lastOwner = 3;

	size_ = size;

	playStandingAnim();
}
PalmTree::~PalmTree() { }

double PalmTree::getStemX(){
	if (size_ == PALM_SMALL) return getX() + 78; // HAX
	else return getX() + 84; // HAX
}
double PalmTree::getStemY(){
	if (size_ == PALM_SMALL) return getY() + 44; // HAX
	else return getY() + 39; // HAX
}

void PalmTree::shake(){
	playShakingAnim();
}

void PalmTree::playStandingAnim(){
	resetAnimation (ANIM_PALM_STAND);
	playAnimation (ANIM_PALM_STAND, true);
}
void PalmTree::playShakingAnim(){
	resetAnimation (ANIM_PALM_SHAKE);
	playAnimation (ANIM_PALM_SHAKE, false);
}
