#ifndef PALMTREE_H
#define PALMTREE_H

#include <string>
#include "sprite.h"


#define PALM_SMALL 0
#define PALM_TALL 1

#define ANIM_PALM_STAND 0
#define ANIM_PALM_SHAKE 1


class PalmTree : public Sprite{
	public:
		PalmTree (Surface* owner, int size = PALM_SMALL);
		virtual ~PalmTree();

		void shake();
		double getStemX(); // Returns the x of where the coconuts should appear
		double getStemY(); // Returns the y of where the coconuts should appear
		int getSize(){ return size_; }
		int getLastOwner(){ return lastOwner; }
		void setLastOwner (int last){ lastOwner = last; }
	private:
		void playStandingAnim();
		void playShakingAnim();

		int lastOwner;

		int size_;
};



#endif
