/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef PUDDLE_H
#define PUDDLE_H

#include <exception>
#include <vector>
#include "sprite.h"

using namespace std;


#define ANIM_PUDDLE 0


/**
	@author Nick Easler,,, <easlern@easlern-laptop>
*/
class Puddle : public LitSprite
{
	public:
   		Puddle (Surface* owner, const double& x = 0, const double& y = 0) : LitSprite (owner, "puddle.bmp"){
			loadAnimations ("puddle.set");
			setAnimationTimeLength (ANIM_PUDDLE, 2000);
			playAnimation (ANIM_PUDDLE, false);
			setXY (x, y);
		}
    	virtual ~Puddle(){}

		virtual std::string getBrightImageFilename() const{ return "puddleBright.bmp"; }

		virtual double getZ(){ return 0; } 

		virtual bool update (unsigned int timePassed){
			bool updateResult = Sprite::update (timePassed);
			return updateResult;
		}

	protected:
};

#endif
