#include "soundInstanceReference.h"
#include "soundInstance.h"
#include <iostream>

using namespace std;


SoundInstanceReference::SoundInstanceReference (SoundInstance* reference) : reference_ (reference) { 
	reference_->setInUse (true);
} 
SoundInstanceReference::~SoundInstanceReference(){
	reference_->setInUse (false);
}

double SoundInstanceReference::getPan(){
	return reference_->getPan();
}
void SoundInstanceReference::setPan (double pan){
	reference_->setPan (pan);
}
double SoundInstanceReference::getVolume(){
	return reference_->getVolume();
}
void SoundInstanceReference::setVolume (double volume){
	reference_->setVolume (volume);
}
Uint32 SoundInstanceReference::getPlayPosition(){
	return reference_->getPlayPosition();
}
void SoundInstanceReference::setPlayPosition (Uint32 position){
	reference_->setPlayPosition (position);
}
Uint32 SoundInstanceReference::getBufferPosition(){
	return reference_->getBufferPosition();
}
void SoundInstanceReference::setBufferPosition (Uint32 position){
	reference_->setBufferPosition (position);
}
Uint32 SoundInstanceReference::getLength(){
	return reference_->getLength();
}
Uint32 SoundInstanceReference::getTimeLength(){
	return reference_->getTimeLength();
}
SoundInstanceReference::State SoundInstanceReference::getState(){
	return (SoundInstanceReference::State) reference_->getState();
}
void SoundInstanceReference::play (bool repeating){
	reference_->play (repeating);
}
void SoundInstanceReference::pause(){
	reference_->pause();
}
void SoundInstanceReference::stop(){
	reference_->stop();
}
std::string SoundInstanceReference::getName(){
	return reference_->getName();
}
bool SoundInstanceReference::hasEffect (AudioEffect* effect){
	return reference_->hasEffect (effect);
}
void SoundInstanceReference::addEffect (AudioEffect* effect){
	reference_->addEffect (effect);
}
void SoundInstanceReference::removeEffect (AudioEffect* effect){
	reference_->removeEffect (effect);
}
