#ifndef SOUND_INSTANCE_REFERENCE_H
#define SOUND_INSTANCE_REFERENCE_H

#include <SDL/SDL.h>
#include <string>
#include <vector>


class SoundInstance;
class AudioEffect;
class SoundInstanceReference{
	public:
		enum State { statePlaying, statePaused, stateStopped, stateRepeating };

		SoundInstanceReference (SoundInstance* reference);
		virtual ~SoundInstanceReference();

		double getPan();
		void setPan (double);
		double getVolume();
		void setVolume (double);
		Uint32 getPlayPosition();
		void setPlayPosition (Uint32);
		Uint32 getBufferPosition();
		void setBufferPosition (Uint32);
		Uint32 getLength();
		Uint32 getTimeLength();
		State getState();
		void play (bool repeating = false);
		void pause();
		void stop();
		std::string getName();
		void addEffect (AudioEffect* effect);
		void removeEffect (AudioEffect* effect);
		bool hasEffect (AudioEffect* effect);

	private:
		SoundInstance* reference_;
};


#endif
