/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "stamp.h"
#include <iostream>

using namespace std;


Stamp::~Stamp(){}

Stamp::Stamp (int offsetX, int offsetY, unsigned int frameWidth, unsigned int frameHeight){
	//cout << "Stamp::Stamp() got " << offsetX << ", " << offsetY << ", " 
    //  << frameWidth << ", " << frameHeight << "." << endl;
    rect.x = offsetX; rect.y = offsetY; rect.w = frameWidth; rect.h = frameHeight;
    //cout << "Stamp's rect is now " << rect.x << ", " << rect.y << ", " 
    //  << rect.w << ", " << rect.h << "." << endl;
}

Stamp::Stamp (StampSettings settings){
    this->rect = settings.getRect();
}

SDL_Rect Stamp::getRect(){
	//cout << "Stamp is returning rect: " << rect.x << ", " << rect.y 
	//	<< ", " << rect.w << ", " << rect.h << "." 
	//	<< endl;
    return rect;
}

Interface_Cloneable* Stamp::clone() const{
    StampSettings settings (rect);
    return new Stamp (settings);
}


