/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef STAMPSET_H
#define STAMPSET_H

#include <iostream>
#include <string>
#include <map>
#include "interface_cloneable.h"
#include "stamp.h"
#include "resourcePool.h"
#include "stampSetSettings.h"


using namespace std;


/**
	@author Nick Easler,,, <easlern@easlern-laptop>
*/

class Stamp;
class StampSet : public Interface_Cloneable{
    public:
        StampSet (ResourcePool* resources, string definitionFile = "");
		StampSet (StampSetSettings settings);
		virtual ~StampSet();

		virtual Interface_Cloneable* clone() const;

        void load (string definitionFile);
        SDL_Surface* getCurrentSurface();
		SDL_Rect getRect (int index);
    
    protected:
		void cleanup();
        map< int, Stamp* > stamps;
        SDL_Surface* image;
		ResourcePool* resources;
};

#endif
