#ifndef SURFACE_HANDLE_H
#define SURFACE_HANDLE_H

#include "surface.h"
#include "interface_surfaceEventObserver.h"


class SurfaceHandle : public Interface_SurfaceEventObserver{
	public:
		SurfaceHandle() : held_ (NULL) { }
		SurfaceHandle (Surface* held) : held_ (held){ 
			if (held_) held_->addSurfaceEventObserver (this);
		}
		SurfaceHandle& operator= (const SurfaceHandle& other){
			if (this != &other){
				SurfaceHandle copy (other.held_);
				if (held_) held_->removeSurfaceEventObserver (this);
				held_ = copy.held_;
				if (held_) held_->addSurfaceEventObserver (this);
			}
			return *this;
		}
		SurfaceHandle (const SurfaceHandle& other){
			*this = other;
		}
		~SurfaceHandle(){
			if (held_) held_->removeSurfaceEventObserver (this);
		}

		Surface* get() const{ return held_; }

		void surfaceDestroying (Surface* caller){
			if (caller == held_) held_ = NULL;
		}
		void perspectiveTransitionsComplete (Surface* caller){ }

	private:
		Surface* held_;
};

#endif
