#include "../eventController.h"
#include "../event.h"
#include "../eventTriggerRequirementEqual.h"
#include "../eventTriggerRequirementNotEqual.h"
#include "../eventTrigger.h"
#include "../eventResultSet.h"
#include "../testUtils.h"
#include "../eventLoader.h"
//#include "../interface_eventControllerObserver.h"
#include <iostream>
using namespace std;


/*
class ControllerObserverStub : public Interface_EventControllerObserver{

	public:

		ControllerObserverStub(){ triggered = 0; }
		~ControllerObserverStub(){}

		void eventTriggered (const Event& event) const{ triggered++; }

		int triggered;

};
*/

int main (int numArgs, char** args){
	
	//ControllerObserverStub observer;
	EventController* controller = new EventController();

	cout << check ("get state test 1", "", controller->getVariable ("doesn't exist yet")) << endl;
	
	controller->setVariable ("exists", "10");
	cout << check ("set state test 1", "10", controller->getVariable ("exists")) << endl;

	Event* event = new Event();
	EventTrigger* trigger = new EventTrigger();
	trigger->addRequirement (new EventTriggerRequirementEqual (EventVariable ("exists", controller), EventValue ("11", controller)));
	event->addResult (new EventResultSet ("result", "69"));
	event->addTrigger (trigger);
	controller->addEvent (event);

	cout << check ("trigger test 1", "", controller->getVariable ("result")) << endl;

	controller->setVariable ("exists", "11");

	cout << check ("trigger test 2", "69", controller->getVariable ("result")) << endl;

	controller->setVariable ("exists", "0");
	controller->setVariable ("result", "0");
	EventTrigger* trigger2 = new EventTrigger();
	trigger2->addRequirement (new EventTriggerRequirementNotEqual (EventVariable ("exists", controller), EventValue ("11", controller)));
	event->addTrigger (trigger2);

	controller->setVariable ("result", "0");
	controller->setVariable ("exists", "11");
	cout << check ("trigger test 3", "69", controller->getVariable ("result")) << endl;

	controller->setVariable ("result", "0");
	controller->setVariable ("exists", "0");
	cout << check ("trigger test 4", "69", controller->getVariable ("result")) << endl;

	delete controller; controller = NULL;


	controller = new EventController();
	cout << check ("event loader test 1", "", controller->getVariable ("passed")) << endl;

	EventLoader loader;
	loader.load ("eventFile.events", controller);

	cout << check ("event loader test 2", "true", controller->getVariable ("passed")) << endl;

	cout << check ("requirement test 1", "success", controller->getVariable ("test_value 1")) << endl;
	cout << check ("requirement test 2", "success", controller->getVariable ("test_value 2")) << endl;
	cout << check ("requirement test 3", "success", controller->getVariable ("test_value 3")) << endl;
	cout << check ("requirement test 4", "success", controller->getVariable ("test_value 4")) << endl;
	cout << check ("requirement test 5", "success", controller->getVariable ("test_value 5")) << endl;
	cout << check ("requirement test 6", "success", controller->getVariable ("test_value 6")) << endl;
	cout << check ("requirement test 7", "", controller->getVariable ("test_value 7")) << endl;
	cout << check ("requirement test 8", "", controller->getVariable ("test_value 8")) << endl;
	cout << check ("requirement test 9", "", controller->getVariable ("test_value 9")) << endl;
	cout << check ("requirement test 10", "", controller->getVariable ("test_value 10")) << endl;

	cout << check ("redirection test 1", "success", controller->getVariable ("test_redirection_1")) << endl;
	cout << check ("redirection test 2", "success", controller->getVariable ("test_redirection_2")) << endl;
	cout << check ("redirection test 3", "success", controller->getVariable ("test_redirection_3")) << endl;
	cout << check ("redirection test 4", "success", controller->getVariable ("test_redirection_4")) << endl;
	cout << check ("redirection test 5", "success", controller->getVariable ("test_redirection_5")) << endl;
	cout << check ("redirection test 6", "success", controller->getVariable ("test_redirection_6")) << endl;

	delete controller; controller = NULL;

	//controller->setVariable ("exists", "0");
	//event.removeTrigger (trigger2);
	
	//controller->addObserver (&observer);

	//controller->setVariable ("exists", "11");
	//cout << check ("observer test 1", 1, observer.triggered) << endl;


	return 0;
}
