#include "../utils.h"
#include "../geometry.h"
#include <iostream>
#include "../testUtils.h"
#include <math.h>
using namespace std;


int main (int numArgs, char** args){
	
	Vector2 vec1 (2, 0);
	Vector2 vec2 (1, 0);
	cout << check ("vec test 1", true, vec1.getNormalized().equals (vec2)) << endl;
	vec1 = Vector2 (3, 0);
	cout << check ("vec test 2", true, vec1.getNormalized().equals (vec2)) << endl;
	vec1 = Vector2 (3, 1);
	vec2 = Vector2 (-3, -1);
	cout << check ("vec test 3", true, vec1.getInverted().equals (vec2)) << endl;
	vec1 = Vector2 (0, 1);
	vec2 = Vector2 (-1, 0);
	cout << check ("vec test 4", true, vec1.getRotated (Utils::PI() * 1 / 2).equals (vec2)) << endl;
	vec1 = Vector2 (0, 1);
	vec2 = Vector2 (0, -1);
	cout << check ("vec test 5", true, vec1.getRotated (Utils::PI() * 2 / 2).equals (vec2)) << endl;
	//cout << vec1.getRotated (Utils::PI() * 2 / 2).toString() << endl;
	vec1 = Vector2 (0, 1);
	vec2 = Vector2 (1, 0);
	cout << check ("vec test 6", true, vec1.getRotated (Utils::PI() * 3 / 2).equals (vec2)) << endl;
	vec1 = Vector2 (0, 1);
	vec2 = Vector2 (0, 1);
	cout << check ("vec test 7", true, vec1.getRotated (Utils::PI() * 4 / 2).equals (vec2)) << endl;

	Line line1 = Line (Point (0, 0), Point (10, 10));
	Line line2 = Line (Point (0, 0), Point (10, 10));
	cout << check ("line intersect test 1", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 2", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 10));
	line2 = Line (Point (10, 10), Point (0, 0));
	cout << check ("line intersect test 3", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 4", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 10));
	line2 = Line (Point (0, 10), Point (10, 0));
	cout << check ("line intersect test 5", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 6", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (10, 0), Point (0, 10));
	line2 = Line (Point (0, 10), Point (10, 0));
	cout << check ("line intersect test 7", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 8", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (0, 10), Point (10, 10));
	cout << check ("line intersect test 9", false, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 10", false, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (2, 0), Point (8, 0));
	cout << check ("line intersect test 11", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 12", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 10));
	line2 = Line (Point (2, 2), Point (8, 8));
	cout << check ("line intersect test 13", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 14", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 10), Point (0, 0));
	line2 = Line (Point (0, 2), Point (0, 8));
	cout << check ("line intersect test 15", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 16", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (0, 10));
	line2 = Line (Point (0, 2), Point (0, 8));
	cout << check ("line intersect test 17", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 18", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (5, 5), Point (5, 0));
	cout << check ("line intersect test 19", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 20", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (5, 5), Point (5, 1));
	cout << check ("line intersect test 21", false, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 22", false, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (10, 0), Point (10, 10));
	cout << check ("line intersect test 23", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 24", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 10));
	line2 = Line (Point (10, 10), Point (20, 0));
	cout << check ("line intersect test 25", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 26", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (5, 0), Point (15, 0));
	cout << check ("line intersect test 27", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 28", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	line2 = Line (Point (5, 5), Point (15, -15));
	cout << check ("line intersect test 29", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 30", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (10, 10), Point (0, 10));
	line2 = Line (Point (5, 5), Point (20, 25));
	cout << check ("line intersect test 31", true, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 32", true, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (5, 5), Point (20, 25));
	line2 = Line (Point (0, 10), Point (0, 0));
	cout << check ("line intersect test 33", false, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 34", false, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 5), Point (0, 5));
	line2 = Line (Point (0, 0), Point (10, 10));
	cout << check ("line intersect test 35", false, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 36", false, line2.intersectsLine (line1)) << endl;
	line1 = Line (Point (0, 5), Point (0, 5));
	line2 = Line (Point (0, 10), Point (0, 10));
	cout << check ("line intersect test 37", false, line1.intersectsLine (line2)) << endl;
	cout << check ("line intersect test 38", false, line2.intersectsLine (line1)) << endl;

	line1 = Line (Point (0, 0), Point (0, 10));
	Point point1 = Point (1, 0);
	cout << check ("line distanceToPoint test 1", 1.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (1, 10);
	cout << check ("line distanceToPoint test 2", 1.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (0, 11);
	cout << check ("line distanceToPoint test 3", 1.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (0, -1);
	cout << check ("line distanceToPoint test 4", 1.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (0, 5);
	cout << check ("line distanceToPoint test 5", 0.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (-10, 10);
	cout << check ("line distanceToPoint test 6", 10.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (-10, 0);
	cout << check ("line distanceToPoint test 7", 10.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (0, 0);
	cout << check ("line distanceToPoint test 8", 0.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (0, 10);
	cout << check ("line distanceToPoint test 9", 0.0, line1.distanceToPoint (point1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 0));
	point1 = Point (0, 1);
	cout << check ("line distanceToPoint test 10", 1.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (10, 1);
	cout << check ("line distanceToPoint test 11", 1.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (0, 0);
	cout << check ("line distanceToPoint test 12", 0.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (10, 0);
	cout << check ("line distanceToPoint test 13", 0.0, line1.distanceToPoint (point1)) << endl;
	line1 = Line (Point (0, 0), Point (10, 10));
	point1 = Point (5, 5);
	cout << check ("line distanceToPoint test 14", 0.0, line1.distanceToPoint (point1)) << endl;
	point1 = Point (11, 11);
	cout << check ("line distanceToPoint test 15", sqrt (2), line1.distanceToPoint (point1)) << endl;
	point1 = Point (-1, -1);
	cout << check ("line distanceToPoint test 16", sqrt (2), line1.distanceToPoint (point1)) << endl;
	line1 = Line (Point (0, 0), Point (0, 10));
	point1 = Point (100, 5);
	cout << check ("line distanceToPoint test 17", 100.0, line1.distanceToPoint (point1)) << endl;
	line1 = Line (Point (1000, 1000), Point (900, 600));
	point1 = Point (900, 0);
	cout << check ("line distanceToPoint test 19", 600.0, line1.distanceToPoint (point1)) << endl;
	line1 = Line (Point (0, 0), Point (100, 100));
	point1 = Point (100, 0);
	cout << check ("line distanceToPoint test 20", sqrt (2) * 50, line1.distanceToPoint (point1)) << endl;	
	line1 = Line (Point (100, 100), Point (0, 0));
	point1 = Point (100, 0);
	cout << check ("line distanceToPoint test 21", sqrt (2) * 50, line1.distanceToPoint (point1)) << endl;	
	line1 = Line (Point (110, 526), Point (168, 560));
	point1 = Point (110, 92);
	cout << check ("line distanceToPoint test 23", 526 - 92.0, line1.distanceToPoint (point1)) << endl;	
	line1 = Line (Point (844, 428), Point (186, 932));
	point1 = Point (315, 844);
	cout << check ("line distanceToPoint test 24", 8.581, line1.distanceToPoint (point1)) << endl;	

	return 0;
}
