/*
	This thing is meant to be used as a map from ints to resources in a graphics app. It's good for a small number of items that 
		are mapped once and accessed many times. I'm using it as a replacement for std::map, which is very general but for my 
		purposes not very fast.
*/


#include <iostream>
#include <vector>

#include <map>

#include "../intMap.h"

using namespace std;


bool inVector (vector<int> vect, int item){
	for (vector<int>::iterator iter = vect.begin(); iter != vect.end(); iter++){
		if (*iter == item) return true;
	}
	return false;
}
int main (int what, char** ever){

	string huh = "one hundred";
	string huh2 = "eleven hundred";
	string huh3 = "one hundred one";
	string* ok = &huh;
	string* ok2 = &huh2;
	string* ok3 = &huh3;
	
	IntMapToPointerHashed<string*> foo;
	cout << "Foo constructed." << endl;

	foo.set (100, ok);
	cout << "Foo set." << endl;

	if (foo.get (100) != NULL) cout << *(foo.get (100)) << " returned." << endl;

	foo.set (101, ok3);
	cout << "Foo set." << endl;

	if (foo.get (101) != NULL) cout << *(foo.get (101)) << " returned." << endl;

	foo.set (1100, ok2);
	cout << "Foo set again." << endl;
	
	if (foo.get (1100) != NULL) cout << *(foo.get (1100)) << " returned." << endl;

	cout << "0xff is " << 0xff << endl;
	cout << "0xfff is " << 0xfff << endl;

	string* strings [INTMAPTOPOINTERHASHED_SLOTS];
	for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x++){
		int valueToSet = x * 100;
		char* num = (char*) malloc (sizeof (char) * 100); num [0] = '\0';
		sprintf (num, "%d", valueToSet);
		char* final = (char*) malloc (sizeof (char) * 100); final [0] = '\0';
		int currentChar = 0;
		if (valueToSet >= 100000){
			final [currentChar] = num [currentChar++];
		}
		if (valueToSet >= 10000){
			final [currentChar] = num [currentChar++];
		}
		if (valueToSet >= 1000){
			final [currentChar] = num [currentChar++];
		}
		if (valueToSet >= 100){
			final [currentChar] = num [currentChar++];
		}
		if (valueToSet >= 10){
			final [currentChar] = num [currentChar++];
		}
		final [currentChar] = num [currentChar++];

		strings [x] = new string (final);
	}

	#ifdef INTMAP_H_COMPARE
	string* junk = NULL;

	foo.clear();
	cout << "Running my map." << endl;
	cout << "SETTING." << endl;
	for (int y = 0; y < 100000; y++){
		for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x += 10){
			foo.set (x, strings [x]);
		}
	}
	cout << "GETTING." << endl;
	for (int y = 0; y < 100000; y++){
		for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x += 10){
			junk = foo.get (x);
		}
	}
	cout << "Done running my map." << endl;

	map<int, string*> whatever;
	cout << "Running STL map." << endl;
	cout << "SETTING." << endl;
	for (int y = 0; y < 100000; y++){
		for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x += 10){
			whatever [x] = strings [x];
		}
	}
	cout << "GETTING." << endl;
	for (int y = 0; y < 100000; y++){
		for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x += 10){
			junk = whatever [x];
		}
	}
	cout << "Done running STL map." << endl;

	cout << "My map collided " << foo.getCollisionCount() << " times." << endl;

	/*
	for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x++){
		cout << *(strings [x]) << endl;
	}
	*/
	#endif	

	for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x++){
		foo.set (x, strings [x]);
	}
	for (int x = 0; x < INTMAPTOPOINTERHASHED_SLOTS; x++){
		if (!foo.get (x) || *strings [x] != *(foo.get (x))){
			cout << "Crap!" << endl;
		}
		if (foo.get (x)){
			cout << *(foo.get (x)) << endl;
		}
	}

	cout << "Collided " << foo.getCollisionCount() << " times." << endl;

	foo.clear();
	foo.set (100, ok); foo.set (1100, ok2); foo.set (101, ok3);
	if ( foo.getKeys().size() == 3 && inVector (foo.getKeys(), 100) && inVector (foo.getKeys(), 1100) && inVector (foo.getKeys(), 101) ){
		cout << "Passed ";
	}
	else cout << "Failed ";
	cout << "getKeys test 1" << endl;

	IntMapToPointerHashed<string*> foo2 = foo;
	if ( foo2.getKeys().size() == 3 && inVector (foo2.getKeys(), 100) && inVector (foo2.getKeys(), 1100) && inVector (foo2.getKeys(), 101) ){
		cout << "Passed ";
	}
	else cout << "Failed ";
	cout << "getKeys test 2" << endl;

	return 0;
}
