#include "../testUtils.h"
#include "../noiseMaker.h"
#include <iostream>
using namespace std;


int main (int numArgs, char** args){

	NoiseMaker noiseMaker1;

	double lowest = 1000;
	double highest = -1000;
	double lastNoise = noiseMaker1.perlinOneDimension (0, 0, 1024);
	for (int x = 1; x < 1024; x++){

		double newNoise = noiseMaker1.perlinOneDimension (x, 0, 1024);

		if (newNoise < lowest) lowest = newNoise;
		if (newNoise > highest) highest = newNoise;

		char junk [1024];
		sprintf (junk, "%d", x);

		cout << check ("locality test " + string (junk), true, fabs (lastNoise - newNoise) < .01) << endl; 
		lastNoise = newNoise;

	}

	cout << "Lowest perlin value: " << lowest << endl;
	cout << "Highest perlin value: " << highest << endl;
	cout << "Perlin (0): " << noiseMaker1.perlinOneDimension (0, 0, 1024) << endl;
	cout << "Perlin (1023): " << noiseMaker1.perlinOneDimension (1023, 0, 1024) << endl;

	cout << check ("range test 1", true, lowest < 0.5) << endl;
	cout << check ("range test 2", true, highest > 0.5) << endl;
	cout << check ("range test 3", true, lowest >= 0.0) << endl;
	cout << check ("range test 4", true, highest <= 1.0) << endl;


	NoiseMaker noiseMaker2;
	NoiseMaker noiseMaker3;

	noiseMaker2.perlinOneDimension (1000, 0, 1000000);
	
	cout << check ("cache test 1", noiseMaker2.perlinOneDimension (1000, 0, 10000), noiseMaker3.perlinOneDimension (1000, 0, 10000)) << endl;
	

	return 0;
}
