WHITE = (255,255,255)
RED = (255,0,0)
GREEN = (0,255,0)
BLUE = (0,0,255)


import Image


def getFileName (snapshotNum):
	return 'pathFinderSnap.' + str (snapshotNum) + '.bmp'

def parseLinesAndDraw (lines, image):
	NO_STATE = 0
	POSSIBLE_STATE = 1
	ADJACENT_STATE = 2

	state = NO_STATE

	line = lines [0]
	del lines [0]
	tokens = line.split()
	keepGoing = True
	while (keepGoing):
		print 'parsing tokens ' + str (tokens)
		if (state == NO_STATE):
			if (tokens [0] == '[POSSIBLE]'):
				possibleX = int (tokens [5].split (',') [0])
				possibleY = int (tokens [5].split (',') [1])
				image.putpixel ((possibleX, possibleY), WHITE)
				state = POSSIBLE_STATE
		elif (state == POSSIBLE_STATE):
			if (tokens [0] == '[ADJACENTS_START]'):
				state = ADJACENT_STATE
			elif (tokens [0] == '[POSSIBLE_DONE]'):
				keepGoing = False
				state = NO_STATE
		elif (state == ADJACENT_STATE):
			if (tokens [0] == '[ADJACENT]'):
				x = int (tokens [1].split (',') [0])
				y = int (tokens [1].split (',') [1])
				if (tokens [2] == '.'):
					image.putpixel ((x,y), GREEN)
				elif (tokens [5] == 'passable'):
					image.putpixel ((x,y), RED)
			elif (tokens [0] == '[ADJACENTS_DONE]'):
				state = POSSIBLE_STATE
		line = lines [0]
		del lines [0]
		tokens = line.split()
	return lines


def __main__():
	snapshot = 0
	image = Image.new ('RGB', (1500,1500))
	#image.putpixel ((0,0),WHITE)
	#image.save ('pathVis.bmp')
	inp = open ('pathVisInput.txt')
	lines = inp.readlines()
	l = 0
	while l < len (lines):
		lines = parseLinesAndDraw (lines, image)
		image.save (getFileName (snapshot))
		snapshot += 1


__main__()
