#include "../quadTree.h"
#include <iostream>
#include <string>
#include <list>
#include "../rect.h"
using namespace std;


template <typename T>
string showSortedList (vector<T> given){
	//cout << "showSortedList: given has " << given.size() << endl;
	list<T> show;
	for (typename vector<T>::iterator iter = given.begin(); iter != given.end(); iter++){
		show.push_back (*iter);
	}
	show.sort();
	string retString = "[";
	for (typename list<T>::iterator iter = show.begin(); iter != show.end(); iter++){
		if (iter != show.begin()) retString += ", ";
		retString += *iter;
	}
	retString += "]";
	return retString;
}

template <typename T>
void checkList (const string& testName, const vector<T>& expected, const vector<T>& got){
	//cout << "checkList: expecting has " << expected.size() << ", got has " << got.size() << endl;
	if (showSortedList<T> (expected) == showSortedList<T> (got)) cout << "Passed " << testName << endl;
	else cout << "Failed " << testName << ". Expected: " << showSortedList<T> (expected) << ", got: " << showSortedList<T> (got) << endl;
}

template <typename T>
void ins (T item, float x, float y, QuadTree<T>& tree, vector<T>& runningList){
	runningList.push_back (item);
	tree.insert (item, x, y);
}

int main (int numArgs, char** args){
	{
		QuadTree<string> tester;
		vector<string> inserted;
		vector<string> junk;

		ins<string> ("69", 0, 0, tester, inserted);
		checkList<string> ("insert test 1", inserted, tester.getItems (Rect (0, 0, 0, 0)));

		ins<string> ("42", 10, 10, tester, inserted);
		checkList<string> ("insert test 2", inserted, tester.getItems (Rect (0, 0, 10, 10)));
		junk.clear();
		checkList<string> ("insert test 3", junk, tester.getItems (Rect (20, 20, 10, 10)));
		junk.push_back (inserted [0]);
		checkList<string> ("insert test 4", junk, tester.getItems (Rect (0, 0, 5, 5)));
		junk.clear(); junk.push_back (inserted [1]);
		checkList<string> ("insert test 5", junk, tester.getItems (Rect (8, 8, 5, 5)));

		ins<string> ("1337", 20, 20, tester, inserted);
		checkList<string> ("insert test 6", inserted, tester.getItems (Rect (0, 0, 20, 20)));
		junk.clear(); junk.push_back (inserted [0]);
		checkList<string> ("insert test 7", junk, tester.getItems (Rect (0, 0, 0, 0)));
		junk.clear(); junk.push_back (inserted [1]);
		checkList<string> ("insert test 8", junk, tester.getItems (Rect (10, 10, 0, 0)));
		junk.clear(); junk.push_back (inserted [2]);
		checkList<string> ("insert test 9", junk, tester.getItems (Rect (20, 20, 0, 0)));
	}
}
