#include "../rect.h"
#include <vector>
#include <iostream>
#include "../testUtils.h"

using namespace std;


string toBinary (unsigned char* source, int byteCount){
    unsigned char* end = &(source [byteCount]);
    string retStr;
    for (unsigned char* next = source; next != end; next++){
        retStr += string (*next & (1 << 7) ? "1" : "0")
            + string (*next & (1 << 6) ? "1" : "0")
            + string (*next & (1 << 5) ? "1" : "0")
            + string (*next & (1 << 4) ? "1" : "0")
            + string (*next & (1 << 3) ? "1" : "0")
            + string (*next & (1 << 2) ? "1" : "0")
            + string (*next & (1 << 1) ? "1" : "0")
            + string (*next & 1 ? "1" : "0")
            + string (" ");
    }
    return retStr;
}

bool inVector (vector< Rect > list, Rect item){
	for (vector< Rect >::iterator iter = list.begin(); iter != list.end(); iter++){
		Rect compare = *iter;
		if (item.equals (compare)){
			return true;
		}
	}
	return false;
}

int main (int numArgs, char** args){

	Rect foo (0, 0, 16, 2);

	string result;
	string testName;

	Rect crap (0, 0, 16, 2);
	Rect what (0, 0, 16, 2);
	Rect trash (0, 0, 14, 2);

	Rect junk;
	Rect cutter;
	vector< Rect > ret;

	// Test 0:4
	junk = Rect (0, 0, 100, 100);
	cutter = Rect (25, 25, 50, 50);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 4 && inVector (ret, Rect (0, 0, 100, 25)) && inVector (ret, Rect (0, 25, 25, 50)) 
			&& inVector (ret, Rect (75, 25, 25, 50)) && inVector (ret, Rect (0, 75, 100, 25)) ){
		cout << "Passed 0:4 test" << endl;
	}
	else{
		cout << "Failed 0:4 test" << endl;
	}
	cout << endl;

	// Test 4:0
	cutter = Rect (0, 0, 100, 100);
	junk = Rect (25, 25, 50, 50);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	if (ret.size() == 0){
		cout << "Passed 4:0 test" << endl;
	}
	else{
		cout << "Failed 4:0 test" << endl;
	}
	cout << endl;

	// Test 0:2
	cutter = Rect (25, 0, 50, 75);
	junk = Rect (0, 25, 100, 75);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 3 && inVector (ret, Rect (0, 25, 25, 50)) && inVector (ret, Rect (75, 25, 25, 50)) 
			&& inVector (ret, Rect (0, 75, 100, 25)) ){
		cout << "Passed 0:2 test" << endl;
	}
	else{
		cout << "Failed 0:2 test" << endl;
	}
	cout << endl;

	// Test 2:0
	junk = Rect (25, 0, 50, 75);
	cutter = Rect (0, 25, 100, 75);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 1 && inVector (ret, Rect (25, 0, 50, 25)) ){
		cout << "Passed 2:0 test" << endl;
	}
	else{
		cout << "Failed 2:0 test" << endl;
	}
	cout << endl;

	// Test 1:1
	junk = Rect (0, 25, 75, 75);
	cutter = Rect (25, 0, 75, 75);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 2 && inVector (ret, Rect (0, 25, 25, 50)) 
			&& inVector (ret, Rect (0, 75, 75, 25)) ){
		cout << "Passed 1:1 test" << endl;
	}
	else{
		cout << "Failed 1:1 test" << endl;
	}
	cout << endl;

	// Test 4:4
	junk = Rect (0, 0, 100, 100);
	cutter = Rect (0, 0, 100, 100);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 0 ){
		cout << "Passed 4:4 test" << endl;
	}
	else{
		cout << "Failed 4:4 test" << endl;
	}
	cout << endl;

	// Test 0:0, no intersect
	junk = Rect (0, 0, 25, 25);
	cutter = Rect (75, 75, 25, 25);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 1 && inVector (ret, Rect (0, 0, 25, 25)) ){
		cout << "Passed 0:0, no intersect test" << endl;
	}
	else{
		cout << "Failed 0:0, no intersect test" << endl;
	}
	cout << endl;

	// Test 0:0, intersect
	junk = Rect (25, 0, 50, 100);
	cutter = Rect (0, 25, 100, 50);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 2 && inVector (ret, Rect (25, 0, 50, 25)) 
			&& inVector (ret, Rect (25, 75, 50, 25)) ){
		cout << "Passed 0:0, intersect test" << endl;
	}
	else{
		cout << "Failed 0:0, intersect test" << endl;
	}
	cout << endl;

	// Test 2:2
	junk = Rect (0, 0, 75, 100);
	cutter = Rect (25, 0, 75, 100);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 1 && inVector (ret, Rect (0, 0, 25, 100)) ){
		cout << "Passed 2:2 test" << endl;
	}
	else{
		cout << "Failed 2:2 test" << endl;
	}
	cout << endl;

	// Test 1:1 kiss
	junk = Rect (0, 0, 50, 50);
	cutter = Rect (50, 50, 50, 50);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 1 && inVector (ret, Rect (0, 0, 50, 50)) ){
		cout << "Passed 1:1 kiss test" << endl;
	}
	else{
		cout << "Failed 1:1 kiss test" << endl;
	}
	cout << endl;

	// Test 4:2
	junk = Rect (0, 0, 50, 100);
	cutter = Rect (0, 0, 100, 100);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 0 ){
		cout << "Passed 4:2 test" << endl;
	}
	else{
		cout << "Failed 4:2 test" << endl;
	}
	cout << endl;

	// Test 2:4
	junk = Rect (0, 0, 100, 100);
	cutter = Rect (0, 0, 50, 100);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 1 && inVector (ret, Rect (50, 0, 50, 100)) ){
		cout << "Passed 2:4 test" << endl;
	}
	else{
		cout << "Failed 2:4 test" << endl;
	}
	cout << endl;

	// Test growth ("pan-in") cutout
	junk = Rect (0, 0, 100, 100);
	cutter = Rect (25, 25, 50, 50);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 4 && inVector (ret, Rect (0, 0, 100, 25)) && inVector (ret, Rect (0, 25, 25, 50)) 
			&& inVector (ret, Rect (75, 25, 25, 50)) && inVector (ret, Rect (0, 75, 100, 25)) ){
		cout << "Passed growth test" << endl;
	}
	else{
		cout << "Failed growth test" << endl;
	}
	cout << endl;

	// Test float cutout
	junk = Rect (0, 0, 10.5, 10);
	cutter = Rect (0, 0, 10, 10);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 1 && inVector (ret, Rect (10, 0, .5, 10)) ){
		cout << "Passed float test 1" << endl;
	}
	else{
		cout << "Failed float test 1" << endl;
	}
	cout << endl;

	// Test complete cut-out
	junk = Rect (0, 0, 100, 100);
	cutter = Rect (0, 0, 100, 100);
	ret = junk.cutOut (cutter);

	cout << "Cutting out created " << ret.size() << " new rects." << endl;
	for (vector< Rect >::iterator iter = ret.begin(); iter != ret.end(); iter++){
		cout << iter->toString() << endl;
	}
	if ( ret.size() == 0 ){
		cout << "Passed complete cut-out test" << endl;
	}
	else{
		cout << "Failed complete cut-out test" << endl;
	}
	cout << endl;

	Rect other;

	// Test intesect-1
	junk = Rect (0, 0, 100, 100);
	other = Rect (200, 200, 100, 100);
	if (junk.intersects (other)){
		cout << "Failed intersect-1 test" << endl;
	}
	else{
		cout << "Passed intersect-1 test" << endl;
	}

	// Test intesect-2
	junk = Rect (0, 0, 100, 100);
	other = Rect (100, 100, 100, 100);
	if (junk.intersects (other)){
		cout << "Failed intersect-2 test" << endl;
	}
	else{
		cout << "Passed intersect-2 test" << endl;
	}

	// Test intesect-3
	junk = Rect (50, 50, 100, 100);
	other = Rect (100, 100, 100, 100);
	if (junk.intersects (other)){
		cout << "Passed intersect-3 test" << endl;
	}
	else{
		cout << "Failed intersect-3 test" << endl;
	}

	// Test intesect-4
	junk = Rect (0, 0, 100, 100);
	other = Rect (0, 0, 100, 100);
	if (junk.intersects (other)){
		cout << "Passed intersect-4 test" << endl;
	}
	else{
		cout << "Failed intersect-4 test" << endl;
	}

	// Test intesect-5.1
	junk = Rect (0, 25, 100, 50);
	other = Rect (25, 0, 50, 100);
	if (junk.intersects (other)){
		cout << "Passed intersect-5.1 test" << endl;
	}
	else{
		cout << "Failed intersect-5.1 test" << endl;
	}

	// Test intesect-5.2
	junk = Rect (25, 0, 50, 100);
	other = Rect (0, 25, 100, 50);
	if (junk.intersects (other)){
		cout << "Passed intersect-5.2 test" << endl;
	}
	else{
		cout << "Failed intersect-5.2 test" << endl;
	}

	// Test intesect-6.1
	junk = Rect (25, 25, 50, 50);
	other = Rect (0, 0, 100, 100);
	if (junk.intersects (other)){
		cout << "Passed intersect-6.1 test" << endl;
	}
	else{
		cout << "Failed intersect-6.1 test" << endl;
	}

	// Test intesect-6.2
	junk = Rect (0, 0, 100, 100);
	other = Rect (25, 25, 50, 50);
	if (junk.intersects (other)){
		cout << "Passed intersect-6.2 test" << endl;
	}
	else{
		cout << "Failed intersect-6.2 test" << endl;
	}


	// Test trim-1
	junk = Rect (0, 0, 100, 100);
	other = Rect (25, 25, 50, 50);
	junk.trimTo (other); 
	other = Rect (25, 25, 50, 50);
	if ( junk.equals (other) ){
		cout << "Passed trim-1 test" << endl;
	}
	else{
		cout << "Failed trim-1 test" << endl;
		cout << junk.toString() << endl;
	}

	// Test trim-2
	junk = Rect (25, 25, 50, 50);
	other = Rect (0, 0, 100, 100);
	junk.trimTo (other); 
	other = Rect (25, 25, 50, 50);
	if ( junk.equals (other) ){
		cout << "Passed trim-2 test" << endl;
	}
	else{
		cout << "Failed trim-2 test" << endl;
		cout << junk.toString() << endl;
	}

	// Test trim-3
	junk = Rect (0, 0, 100, 100);
	other = Rect (25, 25, 100, 100);
	junk.trimTo (other); 
	other = Rect (25, 25, 75, 75);
	if ( junk.equals (other) ){
		cout << "Passed trim-3 test" << endl;
	}
	else{
		cout << "Failed trim-3 test" << endl;
		cout << junk.toString() << endl;
	}

	junk = Rect (0, 0, 10, 10);
	other = Rect (99, 99, 1, 1);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 1", Rect (0, 0, 100, 100).toString(), junk.toString()) << endl;	

	junk = Rect (100, 100, 10, 10);
	other = Rect (99, 99, 1, 1);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 2", Rect (99, 99, 11, 11).toString(), junk.toString()) << endl;

	junk = Rect (0, 0, 100, 100);
	other = Rect (99, 99, 1, 1);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 3", Rect (0, 0, 100, 100).toString(), junk.toString()) << endl;

	junk = Rect (0, 0, 10, 10);
	other = Rect (-1, 0, 10, 10);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 4", Rect (-1, 0, 11, 10).toString(), junk.toString()) << endl;
	
	junk = Rect (0, 0, 10, 10);
	other = Rect (0, -1, 10, 10);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 5", Rect (0, -1, 10, 11).toString(), junk.toString()) << endl;

	junk = Rect (0, 0, 10, 10);
	other = Rect (0, 0, 11, 10);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 6", Rect (0, 0, 11, 10).toString(), junk.toString()) << endl;

	junk = Rect (0, 0, 10, 10);
	other = Rect (0, 0, 10, 11);
	junk.stretchToInclude (other);
	cout << check ("stretch to include test 7", Rect (0, 0, 10, 11).toString(), junk.toString()) << endl;

	junk = Rect (0, 0, 10, 10);
	cout << check ("contains rect test 1.0", true, junk.containsRect (Rect (0, 0, 1, 1))) << endl;
	cout << check ("contains rect test 1.1", true, junk.containsRect (Rect (9, 0, 1, 1))) << endl;
	cout << check ("contains rect test 1.2", true, junk.containsRect (Rect (9, 9, 1, 1))) << endl;
	cout << check ("contains rect test 1.3", true, junk.containsRect (Rect (0, 9, 1, 1))) << endl;
	cout << check ("contains rect test 2.0", false, junk.containsRect (Rect (-1, 0, 2, 2))) << endl;
	cout << check ("contains rect test 2.1", false, junk.containsRect (Rect (0, -1, 2, 2))) << endl;
	cout << check ("contains rect test 2.2", false, junk.containsRect (Rect (9, 9, 2, 2))) << endl;
	cout << check ("contains rect test 2.3", false, junk.containsRect (Rect (0, 9, 2, 2))) << endl;

	junk = Rect (0, 0, 1, 1);
	cout << check ("intersects line test 1.0", true, junk.intersectsLine (Line (Point (0, 0), Point (10, 10)))) << endl;
	cout << check ("intersects line test 1.1", true, junk.intersectsLine (Line (Point (10, 10), Point (0, 0)))) << endl;
	cout << check ("intersects line test 2.0", false, junk.intersectsLine (Line (Point (-10, 0), Point (-10, 10)))) << endl;
	cout << check ("intersects line test 2.1", false, junk.intersectsLine (Line (Point (-10, 0), Point (1, 100)))) << endl;
	cout << check ("intersects line test 2.2", true, junk.intersectsLine (Line (Point (-10, 0), Point (1, 1)))) << endl;
	
	junk = Rect (4, 4, 1, 1);
	cout << check ("intersects line test 100.0", true, junk.intersectsLine (Line (Point (4, 5), Point (5, 5)))) << endl;

	return 0;
}
