#include "../transitionJump.h"
#include "../testUtils.h"
#include <math.h>
#include <iostream>
using namespace std;


int main (int numArgs, char** args){
	
	int pixelToMeterFactor = 1;
	double start = 100.0;
	double end = 200.0;
	double jumpVelocity = 10.0;
	double gravity = 10.0;
	TransitionJump* jump = new TransitionJump (pixelToMeterFactor, start, end, jumpVelocity, gravity);

	// Start at 100.0 .
	cout << check ("get test 1", 100.0, jump->getX()) << endl;

	jump->update (1000);
	// One second passes. Jump velocity affects location and then gravity affects jump velocity.
	cout << check ("get test 2", 90.0, jump->getX()) << endl; 

	jump->update (1000);
	// Another second passes. Jump velocity (now less gravity) affects location and then gravity affects jump velocity.
	cout << check ("get test 3", 90.0, jump->getX()) << endl;

	jump->update (1000);
	cout << check ("get test 4", 100.0, jump->getX()) << endl;

	jump->update (100000);
	// By now, the object should have reached resting state (end), which it won't move past.
	cout << check ("get test 5", 200.0, jump->getX()) << endl;

	delete jump;



	pixelToMeterFactor = 10;
	start = 0.0;
	end = 50.0;
	jumpVelocity = 10.0;
	gravity = 10.0;
	jump = new TransitionJump (pixelToMeterFactor, start, end, jumpVelocity, gravity);

	// Start at 100.0 .
	cout << check ("get test 6", 0.0, jump->getX()) << endl;

	jump->update (1000);
	// One second passes. Jump velocity affects location and then gravity affects jump velocity.
	cout << check ("get test 7", -100.0, jump->getX()) << endl; 

	jump->update (1000);
	// Another second passes. Jump velocity (now less gravity) affects location and then gravity affects jump velocity.
	cout << check ("get test 8", -100.0, jump->getX()) << endl;

	jump->update (1000);
	cout << check ("get test 9", 0.0, jump->getX()) << endl;

	jump->update (100000);
	// By now, the object should have reached resting state (end), which it won't move past.
	cout << check ("get test 10", 50.0, jump->getX()) << endl;

	delete jump;

	return 0;
}
