#ifndef TRANSITION_H
#define TRANSITION_H

#include "interface_cloneable.h"
#include <vector>


class Interface_TransitionObserver;
class Transition : public Interface_Cloneable{
	public:
		Transition (const int& pTimeLengthMs, const double& pStartX = 0.0, const double& pEndX = 0.0);
		virtual ~Transition(){}

		virtual Transition* clone() const = 0;

		virtual bool update (unsigned int timePassed);

		virtual double getX() const = 0;

		virtual bool getLive() const{ return timeLengthMs == -1 || int (timePassedMs) < timeLengthMs; }

		virtual bool addObserver (Interface_TransitionObserver* observer);
		virtual bool removeObserver (Interface_TransitionObserver* observer);

		virtual int getTimeLength() const{ return timeLengthMs; }
		virtual unsigned int getTimePassed() const{ return timePassedMs; }

		virtual double getStartX() const{ return startX; }
		virtual double getEndX() const{ return endX; }

	protected:
		//Transition& operator= (const Transition& model){ return *this; }
		//Transition (const Transition& model){}

		virtual void notifyObserversOfCompletion();

	private:
		int timeLengthMs;

		double startX;
		double endX;

		unsigned int timePassedMs;

		std::vector<Interface_TransitionObserver*> observers;
};


#endif
