#include "transitionDolly.h"
#include <iostream>
#include <math.h>
#include "utils.h"

using namespace std;


TransitionDolly::TransitionDolly (const int& msTime, const double& pStartX, const double& pStartY, const double& pEndX, const double& pEndY) 
		   	   : TwoDimensionalTransition (msTime, pStartX, pStartY, pEndX, pEndY){
	//cout << "TransitionDolly::TransitionDolly() TransitionDolly created" << endl;
}

// Not a proper clone; would need to update() with time passed for that. As is, just makes a new dolly starting at time 0.
TransitionDolly* TransitionDolly::clone() const{
	return new TransitionDolly (getTimeLength(), getStartX(), getStartY(), getEndX(), getEndY());
}

bool TransitionDolly::update (int timePassed){
	//cout << "TransitionDolly::update() TransitionDolly updated" << endl;
	return TwoDimensionalTransition::update (timePassed);
}

double TransitionDolly::getX() const{
	double factor = Utils::logisticFunction (min (1.0, getTimePassed() * 1.0 / getTimeLength()));
	double inverseFactor = 1 - factor;
	double result = (getStartX() * inverseFactor) + (getEndX() * factor);
	if (fabs (result - getEndX()) < 1.0) return getEndX();
	if (fabs (result - getStartX()) < 1.0) return getStartX();
	return result;
}
double TransitionDolly::getY() const{
	double factor = Utils::logisticFunction (min (1.0, getTimePassed() * 1.0 / getTimeLength()));
	double inverseFactor = 1 - factor;
	double result = (getStartY() * inverseFactor) + (getEndY() * factor);
	if (fabs (result - getEndY()) < 1.0) return getEndY();
	if (fabs (result - getStartY()) < 1.0) return getStartY();
	return result;
}
