#include "transitionFall.h"
#include <iostream>
#include <math.h>
#include "utils.h"

using namespace std;


TransitionFall::TransitionFall (const double& pixelToMeterFactor, const double& pStartX, const double& pEndX, const double& metersPerSecond) 
		   	   : Transition (-1, pStartX, pEndX){
	//cout << "Creating fall transition with args " << pStartX << "," << pEndX << endl;
	//cout << "TransitionFall::TransitionFall() TransitionFall created" << endl;
	pixelToMeterFactor_ = pixelToMeterFactor;
	metersPerSecond_ = metersPerSecond;
}

// Not a proper clone; would need to update() with time passed for that. As is, just makes a new fall starting at origin.
TransitionFall* TransitionFall::clone() const{
	return new TransitionFall (pixelToMeterFactor_, getStartX(), getEndX(), metersPerSecond_);
}

bool TransitionFall::update (int timePassed){
	//cout << "TransitionFall::update() TransitionFall updated" << endl;
	return Transition::update (timePassed);
}

double TransitionFall::getX() const{
	double result;
	double totalDistance = fabs (getStartX() - getEndX());
	totalDistance /= pixelToMeterFactor_;
	double distanceTraveled = (1.0 / 2) * metersPerSecond_ * ((getTimePassed() / 1000.0) * (getTimePassed() / 1000.0));
	//distanceTraveled /= pixelToMeterFactor_;
	double percentDone = min (1.0, distanceTraveled / totalDistance);
	result = (getStartX() * (1.0 - percentDone)) + (getEndX() * percentDone);
	//cout << "totalDistance, distanceTraveled, time passed, percentDone, result: " 
	//	 << totalDistance << "," << distanceTraveled << "," << getTimePassed() << "," << percentDone << "," << result << endl;
	return result;
}
