#include "transitionLinearMove.h"
#include <iostream>
#include <math.h>
#include "utils.h"

using namespace std;


TransitionLinearMove::TransitionLinearMove (const int& msTime, const double& pStartX, const double& pEndX) 
		   	   : Transition (msTime, pStartX, pEndX){
	//cout << "TransitionLinearMove::TransitionLinearMove() TransitionLinearMove created" << endl;
}

// Not a proper clone; would need to update() with time passed for that. As is, just makes a new transition starting at time 0.
TransitionLinearMove* TransitionLinearMove::clone() const{
	return new TransitionLinearMove (getTimeLength(), getStartX(), getEndX());
}

bool TransitionLinearMove::update (int timePassed){
	//cout << "TransitionLinearMove::update() TransitionLinearMove updated" << endl;
	return Transition::update (timePassed);
}

double TransitionLinearMove::getPercentDone() const{
	if (getTimeLength() <= 0) return 1.0;
	return min (1.0, getTimePassed() * 1.0 / getTimeLength());
}

double TransitionLinearMove::getX() const{
	if (int (getTimePassed()) >= getTimeLength()){ 
		//cout << "returning end x (" << getEndX() << ")" << endl;
		return getEndX();
	}
	double percentDone = getPercentDone();
	return (percentDone * getEndX()) + ((1.0 - percentDone) * getStartX());
}
