#ifndef TRY_LOCK_H
#define TRY_LOCK_H


#include "interface_lockable.h"
#include <SDL/SDL.h>

class TryLock{
	public:
		TryLock (Interface_Lockable* toLock) : hasLock_ (false), toLock_ (toLock) { }
		virtual ~TryLock(){
			if (hasLock_) toLock_->unlock();
		}

		bool tryLock(){
			if (!hasLock_){
				hasLock_ = toLock_->tryLock();
				return hasLock_;
			}
			return false;
		}
		void unlock(){
			if (hasLock_){
				toLock_->unlock();
				hasLock_ = NULL;
			}
		}

	private:
		bool hasLock_;
		Interface_Lockable* toLock_;
};



#endif
