#ifndef TWO_DIMENSIONAL_TRANSITION_H
#define TWO_DIMENSIONAL_TRANSITION_H

#include "interface_cloneable.h"
#include <vector>
#include "transition.h"


class TwoDimensionalTransition : public Transition{
	public:
		TwoDimensionalTransition (const int& pTimeLengthMs, const double& pStartX = 0.0, const double& pStartY = 0.0, const double& pEndX = 0.0, const double& pEndY = 0.0);
		virtual ~TwoDimensionalTransition(){}

		virtual double getY() const = 0;
		virtual double getStartY() const{ return startY; }
		virtual double getEndY() const{ return endY; }

	protected:
		TwoDimensionalTransition& operator= (const TwoDimensionalTransition& model){ return *this; }
		TwoDimensionalTransition (const TwoDimensionalTransition& model) : Transition (model.getTimeLength(), model.getStartX(), model.getEndX()){}

	private:

		double startY;
		double endY;
};


#endif
