/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef UTIL_TYPES_H
#define UTIL_TYPES_H

#include <iostream>
using namespace std;


namespace Direction{
	enum Direction{ Up, Right, Down, Left };
}

template <class T>
class Optional{
	public:
		Optional() : item_ (NULL) { }
		Optional (const T& item) : item_ (new T (item)) { }
		Optional (const Optional<T>& other){
			item_ = NULL;
			*this = other;
		}
		Optional<T>& operator= (const Optional<T>& other){
			if (&other == this) return *this;
			delete item_;
			if (other.item_) item_ = new T (*(other.item_));
			else item_ = NULL;
			return *this;
		}
		bool operator== (const Optional<T>& other) const{
			if (!item_ && !(other.item_)) return true;
			if (item_ && other.item_) return *item_ == *(other.item_);
			return false;
		}
		~Optional(){
			delete item_;
		}
		bool isSet() const{ return item_ != NULL; }
		T& get() const{ 
			//if (!item_) cout << "NOTHING TO GET!" << endl; 
			return *item_; 
		}

	private:
		T* item_;
};


#endif
