/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#include "utils.h"

Utils::Utils(){}

Utils::~Utils(){}

void Utils::rasterizeLine (std::list <Point>& runningList, const Line& line){
	int x0 (int (line.getPoint1().getX()));
	int x1 (int (line.getPoint2().getX()));
	int y0 (int (line.getPoint1().getY()));
	int y1 (int (line.getPoint2().getY()));
	bool steep = abs (y1 - y0) > abs (x1 - x0);
	bool reversed = false;
	if (steep){
		x0 ^= y0; y0 ^= x0; x0 ^= y0;
		x1 ^= y1; y1 ^= x1; x1 ^= y1;
	}
	if (x0 > x1){
		reversed = true;
		x0 ^= x1; x1 ^= x0; x0 ^= x1;
		y0 ^= y1; y1 ^= y0; y0 ^= y1;
	}
	int deltax = int (x1 - x0);
	int deltay = abs (int (y1 - y0));
	double error = deltax / 2.0;
	int ystep = 0;
	int y = y0;
	if (y0 < y1) ystep = 1;
	else ystep = -1;
	//cout << "x0,y0, x1,y1: " << x0 << ", " << y0 << ", " << x1 << ", " << y1 << endl;
	//cout << "range is " << x0 << "," << (x1 + 1) << endl;
	for (int x = x0; x < x1 + 1; x++){
		if (steep){ 
			if (reversed) runningList.insert (runningList.begin(), Point (y,x));
			//if (reversed) runningList.insert (runningList.begin(), Point (y,x));
			else runningList.push_back (Point (y,x));
			//else runningList.push_back (Point (y,x));
		}
		else{ 
			if (reversed) runningList.insert (runningList.begin(), Point (x,y));
			//if (reversed) runningList.insert (runningList.begin(), Point (x,y));
			else runningList.push_back (Point (x,y));
			//else runningList.push_back (Point (x,y));
		}
		error -= deltay;
		if (x == x1) continue;
		if (error < 0){
			y += ystep;
			error += deltax;
			if (steep){
				if (reversed) runningList.insert (runningList.begin(), Point (y,x));
				//if (reversed) runningList.insert (runningList.begin(), Point (y,x));
				else runningList.push_back (Point (y,x));
				//else runningList.push_back (Point (y,x));
			}
			else{ 
				if (reversed) runningList.insert (runningList.begin(), Point (x,y));
				//if (reversed) runningList.insert (runningList.begin(), Point (x,y));
				else runningList.push_back (Point (x,y));
				//else runningList.push_back (Point (x,y));
			}
		}
	}
}
