/***************************************************************************
 *   Copyright (C) 2008 by Nick Easler,,,   *
 *   easlern@easlern-laptop   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef WALLPAPER_H
#define WALLPAPER_H

#include <iostream>
#include "utils.h"
#include "rect.h"
#include "surface.h"

using namespace std;

/**
	@author Nick Easler,,, <easlern@easlern-laptop>
*/
class ImageProcessingSurfaceManager;
class Wallpaper : public Surface{
    public:
		Wallpaper (Surface* parent = NULL, const string& definition = "", const double& x = 0, const double& y = 0, const double& width = 0, const double& height = 0, 
			const bool& useColorKey = true);
        virtual ~Wallpaper();

		virtual void draw (ImageProcessingSurfaceManager* manager, Surface* screen, 
			const vector<Rect*>* dirtyRectsOverride = NULL, const double& offsetX = 0, const double& offsetY = 0);
		virtual bool update (unsigned int timePassed);

		Rect getSourceImageDimensions();

		void setDefinitionFile (string definition);

		void setWidth (double width);
		void setHeight (double height);
		double getWidth(){ return (getRect() ? getRect()->getWidth() : 0); }
		double getHeight(){ return (getRect() ? getRect()->getHeight() : 0); }

		//virtual vector< Rect > getViewports(){ vector< Rect > what; what.push_back (*getRect()); return what; }

	protected:
		virtual void init (const string& definition = "", const double& x = 0, const double& y = 0, const double& width = 0, const double& height = 0,
			const bool& useColorKey = false);

		void fillSpan();
		void setUpWallpaperSource();

		Surface* sample;

		string definition;

		int widthAlreadyWallpapered;
		int heightAlreadyWallpapered;
};


#endif
